--/////////////////////////////////////////////////////////////////////////////
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 1.11
--  \   \         Application : Virtex-6 FPGA GTH Transceiver Wizard
--  /   /         Filename : v6_gthwizard_v1_11_caui_gth_init.vhd
-- /___/   /\     Timestamp :
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Module v6_gthwizard_v1_11_caui_GTH_INIT
-- Generated by Xilinx Virtex-6 FPGA GTH Transceiver Wizard
-- 
-- 
-- (c) Copyright 2009-2012 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 



library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

--***************************** Entity Declaration ****************************

entity v6_gthwizard_v1_11_caui_GTH_INIT is
generic
(
    FULL_RATE                       : integer := 1; -- 1 = full rate, 0 = divided rate    
    DIV_RATE                        : std_logic_vector(1 downto 0) := "00" -- 00 = full, 01 = 1/2, 10 = 1/4, 11 = 1/8
);
port
(
    TXUSERCLK_IN                    : in std_logic;
    GTHRESET_IN                     : in std_logic;    
    GTHINITDONE_IN                  : in std_logic;
 
    TXCTRLACK_IN                    : in std_logic;
 
    RXCTRLACK_IN                    : in std_logic;  
  
    GTHRESET_OUT                    : out std_logic;
 
    TXPOWERDOWN_OUT                 : out std_logic; 
   
    RXPOWERDOWN_OUT                 : out std_logic;
 
    TXBUFRESET_OUT                  : out std_logic;
 
    RXBUFRESET_OUT                  : out std_logic;
 
    TXRATE_OUT                      : out std_logic_vector(1 downto 0);
 
    RXRATE_OUT                      : out std_logic_vector(1 downto 0);
    SAMPLERATE_OUT                  : out std_logic_vector(1 downto 0);
    RESETDONE_OUT                   : out std_logic
);

end v6_gthwizard_v1_11_caui_GTH_INIT;

architecture RTL of v6_gthwizard_v1_11_caui_GTH_INIT is

--***********************************Parameter Declarations********************

    constant DLY : time := 1 ns;

--******************************Register Declarations**************************

    signal state                               :   std_logic_vector(3 downto 0);
    signal save_state                          :   std_logic_vector(3 downto 0);
    signal state_div_sm                        :   std_logic_vector(4 downto 0);
    signal save_state_div_sm                   :   std_logic_vector(4 downto 0);    
    signal sync_reset_r                        :   std_logic_vector(3 downto 0); --/* synthesis syn_srlstyle = "registers" */ ;
    signal gthreset_r                          :   std_logic;
    signal gthreset_r2                         :   std_logic;
    signal reset_r                             :   std_logic;
    signal txctrlack_r                         :   std_logic;
    signal txbufreset_out_i                    :   std_logic := '0';
    signal samplerate_out_i                    :   std_logic_vector(1 downto 0) := "00";
    signal txrate_out_i                        :   std_logic_vector(1 downto 0) := "00";
    signal txpowerdown_out_i                   :   std_logic := '1';
    signal rxctrlack_r                         :   std_logic;   
    signal rxrate_out_i                        :   std_logic_vector(1 downto 0) := "00";
    signal rxbufreset_out_i                    :   std_logic := '0';
    signal rxpowerdown_out_i                   :   std_logic := '1';
    signal gthinitdone_b_i                     :   std_logic;
    signal gthreset_out_i                      :   std_logic := '0';
    signal resetdone_out_i                     :   std_logic := '0';
    signal done_state                          :   std_logic := '0';


  attribute ASYNC_REG                          : string;
  attribute ASYNC_REG of sync_reset_r          : signal is "TRUE";
    -- synthesis attribute shreg_extract of sync_reset_r is no

    -- Full Rate constants
    constant TXBUFRESET          : std_logic_vector(3 downto 0) := "0000";
    constant TXPOWERDOWN         : std_logic_vector(3 downto 0) := "0001";
    constant RXPOWERDOWN         : std_logic_vector(3 downto 0) := "0010";
    constant RXBUFRESET          : std_logic_vector(3 downto 0) := "0011";
    constant DONE                : std_logic_vector(3 downto 0) := "0100";
    constant WAIT_USR_RST_DEASRT : std_logic_vector(3 downto 0) := "0101";
    constant ASSERT_TXPWRDOWN    : std_logic_vector(3 downto 0) := "0110";
    constant ASSERT_RXPWRDOWN    : std_logic_vector(3 downto 0) := "0111";
    constant GTHRESET            : std_logic_vector(3 downto 0) := "1000";
    constant WAIT_TXCTRLACK      : std_logic_vector(3 downto 0) := "1001";
    constant WAIT_RXCTRLACK      : std_logic_vector(3 downto 0) := "1010";

    -- Divived Rate constants
    constant SET_TXRATE_DIV_SM          : std_logic_vector(4 downto 0) := "00000";
    constant SET_SAMPLERATE_DIV_SM      : std_logic_vector(4 downto 0) := "00001";
    constant TXBUFRESET_DIV_SM          : std_logic_vector(4 downto 0) := "00010";
    constant TXPOWERDOWN_DIV_SM         : std_logic_vector(4 downto 0) := "00011";
    constant SET_RXRATE_DIV_SM          : std_logic_vector(4 downto 0) := "00100";
    constant RXPOWERDOWN_DIV_SM         : std_logic_vector(4 downto 0) := "00101";
    constant RXBUFRESET_DIV_SM          : std_logic_vector(4 downto 0) := "00110";
    constant DONE_DIV_SM                : std_logic_vector(4 downto 0) := "00111";
    constant WAIT_USR_RST_DEASRT_DIV_SM : std_logic_vector(4 downto 0) := "01000";
    constant ASSERT_TXPWRDOWN_DIV_SM    : std_logic_vector(4 downto 0) := "01001";
    constant ASSERT_RXPWRDOWN_DIV_SM    : std_logic_vector(4 downto 0) := "01010";
    constant CLR_TXRATE_DIV_SM          : std_logic_vector(4 downto 0) := "01011";
    constant CLR_SAMPLERATE_DIV_SM      : std_logic_vector(4 downto 0) := "01100";
    constant CLR_RXRATE_DIV_SM          : std_logic_vector(4 downto 0) := "01101";
    constant GTHRESET_DIV_SM            : std_logic_vector(4 downto 0) := "01110";
    constant WAIT_TXCTRLACK_DIV_SM      : std_logic_vector(4 downto 0) := "01111";
    constant WAIT_RXCTRLACK_DIV_SM      : std_logic_vector(4 downto 0) := "10000";

begin

    gthinitdone_b_i <= not GTHINITDONE_IN;
    
    process (TXUSERCLK_IN, gthinitdone_b_i)
    begin
        if (gthinitdone_b_i = '1') then
            sync_reset_r <= "1111" after DLY;
        elsif (rising_edge(TXUSERCLK_IN)) then
            sync_reset_r <= '0' & sync_reset_r(3 downto 1) after DLY;
        end if;
    end process;

    process (TXUSERCLK_IN)
    begin
        if (rising_edge(TXUSERCLK_IN)) then    
            reset_r <= sync_reset_r(0) after DLY;    
        end if;
    end process;

    -- Capture gthreset on TXUSERCLK domain
    process(TXUSERCLK_IN)
    begin
        if(TXUSERCLK_IN'event and TXUSERCLK_IN = '1') then
            if(reset_r = '1') then
                gthreset_r  <= '0' after DLY;
                gthreset_r2 <= '0' after DLY;
            else
                gthreset_r <= GTHRESET_IN after DLY;
                gthreset_r2 <= gthreset_r after DLY;
            end if;
        end if;
    end process;
    
 
    -- Register TXCTRLACK once to ease timing
    process(TXUSERCLK_IN)
    begin
        if(TXUSERCLK_IN'event and TXUSERCLK_IN = '1') then
            txctrlack_r <= TXCTRLACK_IN after DLY;
        end if;
    end process;

 
    -- Register RXCTRLACK once to ease timing
    process(TXUSERCLK_IN)
    begin
        if(TXUSERCLK_IN'event and TXUSERCLK_IN = '1') then
            rxctrlack_r <= RXCTRLACK_IN after DLY;        
        end if;
    end process;
    
 
    TXBUFRESET_OUT  <= txbufreset_out_i;
    TXPOWERDOWN_OUT <= txpowerdown_out_i;
    TXRATE_OUT      <= txrate_out_i;
    SAMPLERATE_OUT  <= samplerate_out_i;
 
    RXPOWERDOWN_OUT <= rxpowerdown_out_i;
    RXBUFRESET_OUT  <= rxbufreset_out_i;
    RXRATE_OUT      <= rxrate_out_i;
    RESETDONE_OUT   <= resetdone_out_i;
    GTHRESET_OUT    <= gthreset_out_i;


full_rate_sm : if FULL_RATE = 1 generate

    process(TXUSERCLK_IN)
    begin
        if(TXUSERCLK_IN'event and TXUSERCLK_IN = '1') then
            if(reset_r = '1') then
                done_state      <=    '0' after DLY;
 
                txpowerdown_out_i <=  '1' after DLY;
 
                rxpowerdown_out_i <=  '1' after DLY;
 
                txbufreset_out_i  <=  '0' after DLY;
                resetdone_out_i   <=  '0' after DLY;
 
                rxbufreset_out_i  <=  '0' after DLY;
                gthreset_out_i    <=  '0' after DLY;
                save_state        <=  TXBUFRESET after DLY;
                state             <=  TXBUFRESET after DLY;
            else
                case state is
                    when TXBUFRESET =>
                    
                        txbufreset_out_i <= '1' after DLY;
                        state <= TXPOWERDOWN after DLY;
                        
                    when TXPOWERDOWN =>
                    
                        txbufreset_out_i  <= '0' after DLY;
                        txpowerdown_out_i <= '0' after DLY;
                        save_state <= RXPOWERDOWN after DLY;
   
                        if (txctrlack_r = '1') then
                            state <= WAIT_TXCTRLACK after DLY;
                        else
                            state <= TXPOWERDOWN after DLY;
                        end if;
                
         
                    when RXPOWERDOWN =>
                    
                        rxpowerdown_out_i <= '0' after DLY;
                        save_state <= RXBUFRESET after DLY;
                        if (rxctrlack_r = '1') then
                            state <= WAIT_RXCTRLACK after DLY;
                        else
                            state <= RXPOWERDOWN after DLY;
                        end if;
                        
                    when RXBUFRESET =>
                    
                        rxbufreset_out_i <= '1' after DLY;
                        if(done_state = '1') then
                          state <= GTHRESET after DLY; 
                        else
                          state <= DONE after DLY;
                        end if;       
                    
                    when DONE =>
                        done_state <= '1' after DLY;
                    
                        rxbufreset_out_i <= '0' after DLY;
   
                        resetdone_out_i <= '1' after DLY;
                        if (gthreset_r2 = '1') then
                            state <= WAIT_USR_RST_DEASRT after DLY;
                        else
                            state <= DONE after DLY;
                        end if;
                        
                    when WAIT_USR_RST_DEASRT =>
                    
                        resetdone_out_i <= '0' after DLY;                        
                        if (gthreset_r2 = '1') then
                            state <= WAIT_USR_RST_DEASRT after DLY;
                        else
                            state <= ASSERT_TXPWRDOWN after DLY;
  
                        end if;                        
                        
                    when ASSERT_TXPWRDOWN =>
                    
                        txpowerdown_out_i <= '1' after DLY;
  
                        save_state <= ASSERT_RXPWRDOWN after DLY;
                        if (txctrlack_r = '1') then
                            state <= WAIT_TXCTRLACK after DLY;
                        else
                            state <= ASSERT_TXPWRDOWN after DLY;
                        end if;
                        
 
                    when ASSERT_RXPWRDOWN =>
                        
                        rxpowerdown_out_i <= '1' after DLY;
 
                        save_state <= TXBUFRESET after DLY;
                        if (rxctrlack_r = '1') then
                            state <= WAIT_RXCTRLACK after DLY;
                        else
                            state <= ASSERT_RXPWRDOWN after DLY;
                        end if;
                            
                    when GTHRESET =>
                    
                        gthreset_out_i <= '1' after DLY;
                        state <= GTHRESET after DLY;
                    
                    when WAIT_TXCTRLACK =>
                    
                        if (txctrlack_r = '1') then
                            state <= WAIT_TXCTRLACK after DLY;
                        else
                            case save_state is
                                when GTHRESET => state <= GTHRESET after DLY;
                                when TXBUFRESET => state <= TXBUFRESET after DLY;
                                when TXPOWERDOWN => state <= TXPOWERDOWN after DLY;
                                when RXPOWERDOWN => state <= RXPOWERDOWN after DLY;
                                when ASSERT_RXPWRDOWN => state <= ASSERT_RXPWRDOWN after DLY;
                                when others => state <= DONE after DLY;
                            end case;
                        end if;
  
  
                    when WAIT_RXCTRLACK =>
                    
                        if (rxctrlack_r = '1') then
                            state <= WAIT_RXCTRLACK after DLY;
                        else
                            case save_state is
                               when TXBUFRESET => state <= TXBUFRESET after DLY;
                               when RXBUFRESET => state <= RXBUFRESET after DLY;
                               when RXPOWERDOWN => state <= RXPOWERDOWN after DLY;
                               when GTHRESET => state <= GTHRESET after DLY;
                               when others => state <= DONE after DLY;
                            end case;
                        end if;
  
                    when others => state <= TXBUFRESET after DLY;
                end case;
            end if;
        end if;
    end process;

end generate full_rate_sm;

divided_rate_sm : if FULL_RATE = 0 generate 

    process(TXUSERCLK_IN)
    begin
        if(TXUSERCLK_IN'event and TXUSERCLK_IN = '1') then
            if(reset_r = '1') then
   
                txpowerdown_out_i <=  '1' after DLY;
                txrate_out_i      <=  "00" after DLY;
                txbufreset_out_i  <=  '0' after DLY;
                samplerate_out_i  <=  "00" after DLY;
   
                rxpowerdown_out_i <=  '1' after DLY;
                rxrate_out_i      <=  "00" after DLY;
                rxbufreset_out_i  <=  '0' after DLY;
                resetdone_out_i   <=  '0' after DLY;
                gthreset_out_i    <=  '0' after DLY;
                save_state_div_sm <=  SET_TXRATE_DIV_SM after DLY;
                state_div_sm      <=  SET_TXRATE_DIV_SM after DLY;
                done_state        <=  '0' after DLY;
            else
                case state_div_sm is
 
                    when SET_TXRATE_DIV_SM =>
                    
                        txrate_out_i <= DIV_RATE after DLY;
                        save_state_div_sm <= SET_SAMPLERATE_DIV_SM after DLY;
                        if (txctrlack_r = '1') then
                            state_div_sm <= WAIT_TXCTRLACK_DIV_SM after DLY;
                        else 
                            state_div_sm <= SET_TXRATE_DIV_SM after DLY;
                        end if;
                        
                    when SET_SAMPLERATE_DIV_SM =>
                
                        samplerate_out_i <= DIV_RATE after DLY;
                        save_state_div_sm <= TXBUFRESET_DIV_SM after DLY;
                        if (txctrlack_r = '1') then
                            state_div_sm <= WAIT_TXCTRLACK_DIV_SM after DLY;
                        else
                            state_div_sm <= SET_SAMPLERATE_DIV_SM after DLY;
                        end if;
                
                    when TXBUFRESET_DIV_SM =>
                    
                        txbufreset_out_i <= '1' after DLY;
                        state_div_sm <= TXPOWERDOWN_DIV_SM after DLY;
                    
                    when TXPOWERDOWN_DIV_SM => 
                    
                        txbufreset_out_i <= '0' after DLY;
                        txpowerdown_out_i <= '0' after DLY;
                        if (done_state = '1') then 
                          save_state_div_sm <= RXPOWERDOWN_DIV_SM after DLY;
                        else
                          save_state_div_sm <= SET_RXRATE_DIV_SM after DLY;
                        end if;

                        if (txctrlack_r = '1') then
                            state_div_sm <= WAIT_TXCTRLACK_DIV_SM after DLY;
                        else
                            state_div_sm <= TXPOWERDOWN_DIV_SM after DLY;
                        end if;
            
             
                    when SET_RXRATE_DIV_SM =>
                    
                        rxrate_out_i <= DIV_RATE after DLY;
                        save_state_div_sm <= RXPOWERDOWN_DIV_SM after DLY;
                        if (rxctrlack_r = '1') then
                            state_div_sm <= WAIT_RXCTRLACK_DIV_SM after DLY;
                        else 
                            state_div_sm <= SET_RXRATE_DIV_SM after DLY;
                        end if;
                        
                    when RXPOWERDOWN_DIV_SM =>
                    
                        rxpowerdown_out_i <= '0' after DLY;
                        save_state_div_sm <= RXBUFRESET_DIV_SM after DLY;
                        if (rxctrlack_r = '1') then
                            state_div_sm <= WAIT_RXCTRLACK_DIV_SM after DLY;
                        else
                            state_div_sm <= RXPOWERDOWN_DIV_SM after DLY;
                        end if;
                        
                    when RXBUFRESET_DIV_SM =>
                    
                        rxbufreset_out_i <= '1' after DLY;
                        if (done_state = '1') then 
                          state_div_sm <= GTHRESET_DIV_SM after DLY;
                        else 
                          state_div_sm <= DONE_DIV_SM after DLY;
                        end if;
                    
                    when DONE_DIV_SM =>
                        done_state <= '1';
                    
                        rxbufreset_out_i <= '0'after DLY;
  
                        resetdone_out_i <= '1' after DLY;
                        if (gthreset_r2 = '1') then
                            state_div_sm <= WAIT_USR_RST_DEASRT_DIV_SM after DLY;
                        else
                            state_div_sm <= DONE_DIV_SM after DLY;
                        end if;
 
                     when WAIT_USR_RST_DEASRT_DIV_SM =>
                     
                         resetdone_out_i <= '0' after DLY;                        
                         if (gthreset_r2 = '1') then
                             state_div_sm <= WAIT_USR_RST_DEASRT_DIV_SM after DLY;
                         else
                             state_div_sm <= ASSERT_TXPWRDOWN_DIV_SM after DLY;
  
                        end if;      
  
                    when ASSERT_TXPWRDOWN_DIV_SM =>
                    
                        txpowerdown_out_i <= '1' after DLY;
                        save_state_div_sm <= ASSERT_RXPWRDOWN_DIV_SM after DLY;
  
                        if (txctrlack_r = '1') then
                            state_div_sm <= WAIT_TXCTRLACK_DIV_SM after DLY;
                        else
                            state_div_sm <= ASSERT_TXPWRDOWN_DIV_SM after DLY;
                        end if;
              
          
                    when ASSERT_RXPWRDOWN_DIV_SM =>
                    
                        rxpowerdown_out_i <= '1' after DLY;
                        save_state_div_sm <= CLR_TXRATE_DIV_SM after DLY;
  
                        if (rxctrlack_r = '1') then
                            state_div_sm <= WAIT_RXCTRLACK_DIV_SM after DLY;
                        else
                            state_div_sm <= ASSERT_RXPWRDOWN_DIV_SM after DLY;
                        end if;
                       
                    when CLR_TXRATE_DIV_SM =>
                    
                        txrate_out_i <= "00" after DLY;
                        save_state_div_sm <= CLR_SAMPLERATE_DIV_SM after DLY;
                        if (txctrlack_r = '1') then
                            state_div_sm <= WAIT_TXCTRLACK_DIV_SM after DLY;
                        else
                            state_div_sm <= CLR_TXRATE_DIV_SM after DLY;
                        end if;
                    
                    when CLR_SAMPLERATE_DIV_SM =>
                    
                        samplerate_out_i <= "00" after DLY;
         
                        save_state_div_sm <= CLR_RXRATE_DIV_SM after DLY;
                        if (txctrlack_r = '1') then
                            state_div_sm <= WAIT_TXCTRLACK_DIV_SM after DLY;
                        else 
                            state_div_sm <= CLR_SAMPLERATE_DIV_SM after DLY;
                        end if;
                       
                    when CLR_RXRATE_DIV_SM =>
                    
                        rxrate_out_i <= "00" after DLY;
   
                        save_state_div_sm <= TXBUFRESET_DIV_SM after DLY;
                        if (rxctrlack_r = '1') then 
                            state_div_sm <= WAIT_RXCTRLACK_DIV_SM after DLY;
                        else
                            state_div_sm <= CLR_RXRATE_DIV_SM after DLY;
                        end if;
                    
                    when GTHRESET_DIV_SM =>
                    
                        gthreset_out_i <= '1' after DLY;
                      
                    when WAIT_TXCTRLACK_DIV_SM =>
                    
                        if (txctrlack_r = '1') then
                            state_div_sm <= WAIT_TXCTRLACK_DIV_SM after DLY;
                        else
                            case save_state_div_sm is
                                when SET_SAMPLERATE_DIV_SM   => state_div_sm <= SET_SAMPLERATE_DIV_SM after DLY;
                                when TXBUFRESET_DIV_SM       => state_div_sm <= TXBUFRESET_DIV_SM after DLY;
                                when SET_RXRATE_DIV_SM       => state_div_sm <= SET_RXRATE_DIV_SM after DLY;
                                when ASSERT_RXPWRDOWN_DIV_SM => state_div_sm <= ASSERT_RXPWRDOWN_DIV_SM after DLY;                                               
                                when CLR_SAMPLERATE_DIV_SM   => state_div_sm <= CLR_SAMPLERATE_DIV_SM after DLY;
                                when CLR_TXRATE_DIV_SM       => state_div_sm <= CLR_TXRATE_DIV_SM after DLY; 
                                when CLR_RXRATE_DIV_SM       => state_div_sm <= CLR_RXRATE_DIV_SM after DLY;                                                
                                when GTHRESET_DIV_SM         => state_div_sm <= GTHRESET_DIV_SM after DLY;     
                                when RXPOWERDOWN_DIV_SM      => state_div_sm <= RXPOWERDOWN_DIV_SM after DLY;                                              
                                when others                  => state_div_sm <= DONE_DIV_SM after DLY;
                            end case;
                        end if;                  
                       
                    when WAIT_RXCTRLACK_DIV_SM => 
                    
                        if (rxctrlack_r = '1') then
                            state_div_sm <= WAIT_RXCTRLACK_DIV_SM after DLY;
                        else
                            case save_state_div_sm is
                                when RXPOWERDOWN_DIV_SM  => state_div_sm <= RXPOWERDOWN_DIV_SM after DLY;
                                when TXBUFRESET_DIV_SM   => state_div_sm <= TXBUFRESET_DIV_SM after DLY;
                                when RXBUFRESET_DIV_SM   => state_div_sm <= RXBUFRESET_DIV_SM after DLY;
                                when CLR_TXRATE_DIV_SM   => state_div_sm <= CLR_TXRATE_DIV_SM after DLY;
                                when CLR_RXRATE_DIV_SM       => state_div_sm <= CLR_RXRATE_DIV_SM after DLY;  
                                when GTHRESET_DIV_SM     => state_div_sm <= GTHRESET_DIV_SM after DLY;
                                when others              => state_div_sm <= DONE_DIV_SM after DLY;
                            end case;            
                        end if;                  
                                               
                    when others => state_div_sm <= SET_TXRATE_DIV_SM after DLY;   
 
                end case;                    
            end if;                    
        end if;                    
    end process;
              
end generate divided_rate_sm;

end RTL; 




