-------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 1.11
--  \   \         Application : Virtex-6 FPGA GTH Transceiver Wizard
--  /   /         Filename : v6_gthwizard_v1_11_caui_quad.vhd
-- /___/   /\     Timestamp :
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Module v6_gthwizard_v1_11_caui_QUAD (a QUAD Wrapper)
-- Generated by Xilinx Virtex-6 FPGA GTH Transceiver Wizard
-- 
-- 
-- (c) Copyright 2009-2012 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

--***************************** Entity Declaration ****************************

entity v6_gthwizard_v1_11_caui_QUAD is
generic
(
-- Simulation attributes
    QUAD_SIM_GTHRESET_SPEEDUP   : integer   := 0      -- Set to 1 to speed up sim reset
);
port 
(
    --------------------------------- Resetdone --------------------------------
    TX_PCS_RESETDONE0_OUT          : out  std_logic;
    RX_PCS_CDR_RESETDONE0_OUT      : out  std_logic;
    TX_PCS_RESETDONE1_OUT          : out  std_logic;
    RX_PCS_CDR_RESETDONE1_OUT      : out  std_logic;
    TX_PCS_RESETDONE2_OUT          : out  std_logic;
    RX_PCS_CDR_RESETDONE2_OUT      : out  std_logic;
    TX_PCS_RESETDONE3_OUT          : out  std_logic;
    RX_PCS_CDR_RESETDONE3_OUT      : out  std_logic;
    --------------------------------- Initdone ---------------------------------
    GTHINITDONE_OUT                         : out  std_logic;
    --------------------------------- PCS Resets -------------------------------
    TX_PCS_RESET0_IN               : in  std_logic;
    RX_PCS_CDR_RESET0_IN           : in  std_logic;
    TX_PCS_RESET1_IN               : in  std_logic;
    RX_PCS_CDR_RESET1_IN           : in  std_logic;
    TX_PCS_RESET2_IN               : in  std_logic;
    RX_PCS_CDR_RESET2_IN           : in  std_logic;
    TX_PCS_RESET3_IN               : in  std_logic;
    RX_PCS_CDR_RESET3_IN           : in  std_logic;
    --------------------------------- Powerdown --------------------------------
    POWERDOWN0_IN                           : in   std_logic;
    POWERDOWN1_IN                           : in   std_logic;
    POWERDOWN2_IN                           : in   std_logic;
    POWERDOWN3_IN                           : in   std_logic;
    RXPOWERDOWN0_IN                         : in   std_logic_vector(1 downto 0);
    RXPOWERDOWN1_IN                         : in   std_logic_vector(1 downto 0);
    RXPOWERDOWN2_IN                         : in   std_logic_vector(1 downto 0);
    RXPOWERDOWN3_IN                         : in   std_logic_vector(1 downto 0);
    TXPOWERDOWN0_IN                         : in   std_logic_vector(1 downto 0);
    TXPOWERDOWN1_IN                         : in   std_logic_vector(1 downto 0);
    TXPOWERDOWN2_IN                         : in   std_logic_vector(1 downto 0);
    TXPOWERDOWN3_IN                         : in   std_logic_vector(1 downto 0);
    ------------------------------- Receive Ports ------------------------------
    RXBUFRESET0_IN                          : in   std_logic;
    RXBUFRESET1_IN                          : in   std_logic;
    RXBUFRESET2_IN                          : in   std_logic;
    RXBUFRESET3_IN                          : in   std_logic;
    RXCTRLACK0_OUT                          : out  std_logic;
    RXCTRLACK1_OUT                          : out  std_logic;
    RXCTRLACK2_OUT                          : out  std_logic;
    RXCTRLACK3_OUT                          : out  std_logic;
    RXDATA0_OUT                             : out  std_logic_vector(63 downto 0);
    RXDATA1_OUT                             : out  std_logic_vector(63 downto 0);
    RXDATA2_OUT                             : out  std_logic_vector(63 downto 0);
    RXDATA3_OUT                             : out  std_logic_vector(63 downto 0);
    RXN0_IN                                 : in   std_logic;
    RXN1_IN                                 : in   std_logic;
    RXN2_IN                                 : in   std_logic;
    RXN3_IN                                 : in   std_logic;
    RXP0_IN                                 : in   std_logic;
    RXP1_IN                                 : in   std_logic;
    RXP2_IN                                 : in   std_logic;
    RXP3_IN                                 : in   std_logic;
    RXSLIP0_IN                              : in   std_logic;
    RXSLIP1_IN                              : in   std_logic;
    RXSLIP2_IN                              : in   std_logic;
    RXSLIP3_IN                              : in   std_logic;
    RXUSERCLKIN0_IN                         : in   std_logic;
    RXUSERCLKIN1_IN                         : in   std_logic;
    RXUSERCLKIN2_IN                         : in   std_logic;
    RXUSERCLKIN3_IN                         : in   std_logic;
    RXUSERCLKOUT0_OUT                       : out  std_logic;
    RXUSERCLKOUT1_OUT                       : out  std_logic;
    RXUSERCLKOUT2_OUT                       : out  std_logic;
    RXUSERCLKOUT3_OUT                       : out  std_logic;
    ------------- Shared Ports - Dynamic Reconfiguration Port (DRP) ------------
    DADDR_IN                                : in   std_logic_vector(15 downto 0);
    DCLK_IN                                 : in   std_logic;
    DEN_IN                                  : in   std_logic;
    DI_IN                                   : in   std_logic_vector(15 downto 0);
    DISABLEDRP_IN                           : in   std_logic;
    DRDY_OUT                                : out  std_logic;
    DRPDO_OUT                               : out  std_logic_vector(15 downto 0);
    DWE_IN                                  : in   std_logic;
    ---------------------------- Shared Ports - Other --------------------------
    GTHINIT_IN                              : in   std_logic;
    GTHRESET_IN                             : in   std_logic;
    MGMTPCSLANESEL_IN                       : in   std_logic_vector(3 downto 0);
    MGMTPCSMMDADDR_IN                       : in   std_logic_vector(4 downto 0);
    MGMTPCSRDACK_OUT                        : out  std_logic;
    MGMTPCSRDDATA_OUT                       : out  std_logic_vector(15 downto 0);
    MGMTPCSREGADDR_IN                       : in   std_logic_vector(15 downto 0);
    MGMTPCSREGRD_IN                         : in   std_logic;
    MGMTPCSREGWR_IN                         : in   std_logic;
    MGMTPCSWRDATA_IN                        : in   std_logic_vector(15 downto 0);
    REFCLK_IN                               : in   std_logic;
    GTH_REFCLK_OUT                          : OUT  STD_LOGIC;
    ------------------------------- Transmit Ports -----------------------------
    TXBUFRESET0_IN                          : in   std_logic;
    TXBUFRESET1_IN                          : in   std_logic;
    TXBUFRESET2_IN                          : in   std_logic;
    TXBUFRESET3_IN                          : in   std_logic;
    TXCTRLACK0_OUT                          : out  std_logic;
    TXCTRLACK1_OUT                          : out  std_logic;
    TXCTRLACK2_OUT                          : out  std_logic;
    TXCTRLACK3_OUT                          : out  std_logic;
    TXDATA0_IN                              : in   std_logic_vector(63 downto 0);
    TXDATA1_IN                              : in   std_logic_vector(63 downto 0);
    TXDATA2_IN                              : in   std_logic_vector(63 downto 0);
    TXDATA3_IN                              : in   std_logic_vector(63 downto 0);
    TXN0_OUT                                : out  std_logic;
    TXN1_OUT                                : out  std_logic;
    TXN2_OUT                                : out  std_logic;
    TXN3_OUT                                : out  std_logic;
    TXP0_OUT                                : out  std_logic;
    TXP1_OUT                                : out  std_logic;
    TXP2_OUT                                : out  std_logic;
    TXP3_OUT                                : out  std_logic;
    TXUSERCLKIN0_IN                         : in   std_logic;
    TXUSERCLKIN1_IN                         : in   std_logic;
    TXUSERCLKIN2_IN                         : in   std_logic;
    TXUSERCLKIN3_IN                         : in   std_logic;
    TXUSERCLKOUT0_OUT                       : out  std_logic;
    TXUSERCLKOUT1_OUT                       : out  std_logic;
    TXUSERCLKOUT2_OUT                       : out  std_logic;
    TXUSERCLKOUT3_OUT                       : out  std_logic

);


end v6_gthwizard_v1_11_caui_QUAD;

architecture RTL of v6_gthwizard_v1_11_caui_QUAD is

    component v6_gthwizard_v1_11_caui_GTH_RESET
    port
    (
        DCLK_IN                     : in  std_logic;
        RESET_IN                    : in  std_logic;
        USER_GTHRESET_IN            : in  std_logic;
        CTRLACK_IN                  : in  std_logic;
        MGMTPCSLANESEL_OUT          : out std_logic_vector(3 downto 0);
        MGMTPCSMMDADDR_OUT          : out std_logic_vector(4 downto 0);
        MGMTPCSREGADDR_OUT          : out std_logic_vector(15 downto 0);
        MGMTPCSREGRD_OUT            : out std_logic;
        MGMTPCSREGWR_OUT            : out std_logic;
        MGMTPCSWRDATA_OUT           : out std_logic_vector(15 downto 0);
        GTHINITDONE_IN              : in  std_logic;
        GTHINITDONE_OUT             : out std_logic;
        MGMTPCSRDACK_IN             : in  std_logic;
        MGMTPCSRDDATA_IN            : in  std_logic_vector(15 downto 0);
        DISABLEDRP_OUT              : out std_logic;
        GTHRESET_OUT                : out std_logic;
        GTHINIT_OUT                 : out std_logic        
    );
    end component;

    component v6_gthwizard_v1_11_caui_GTH_INIT
    generic
    (
        FULL_RATE                   : integer := 1;
        DIV_RATE                    : std_logic_vector(1 downto 0) := "00"
    );
    port
    (
        TXUSERCLK_IN                    : in std_logic;
        GTHRESET_IN                     : in std_logic;    
        GTHINITDONE_IN                  : in std_logic;
        TXCTRLACK_IN                    : in std_logic;
        RXCTRLACK_IN                    : in std_logic;   
 
        GTHRESET_OUT                    : out std_logic;
        TXPOWERDOWN_OUT                 : out std_logic;  
 
        RXPOWERDOWN_OUT                 : out std_logic;
 
        TXBUFRESET_OUT                  : out std_logic;
 
        RXBUFRESET_OUT                  : out std_logic;
 
        TXRATE_OUT                      : out std_logic_vector(1 downto 0);
 
        RXRATE_OUT                      : out std_logic_vector(1 downto 0);
 
        SAMPLERATE_OUT                  : out std_logic_vector(1 downto 0);
        RESETDONE_OUT                   : out std_logic
    );
    end component;

    component v6_gthwizard_v1_11_caui_GTH_TX_PCS_RESET
    port
    (
        TXUSERCLK_IN            : in  std_logic;
        RESET_IN                : in  std_logic;
        TXPCSRESET_IN           : in  std_logic;
        TXCTRLACK_IN            : in  std_logic;
        TXBUFRESET_OUT          : out std_logic;
        TXPOWERDOWN_OUT         : out std_logic;
        TXPCSRESETDONE_OUT      : out std_logic
    );
    end component;

    
    component v6_gthwizard_v1_11_caui_GTH_RX_PCS_CDR_RESET
    port
    (
        TXUSERCLK_IN            : in  std_logic;
        RESET_IN                : in  std_logic;
        RXPCSRESET_IN           : in  std_logic;       
        RXCTRLACK_IN            : in  std_logic;
        RXBUFRESET_OUT          : out std_logic;
        RXPOWERDOWN_OUT         : out std_logic;
        RXPCSCDRRESETDONE_OUT   : out std_logic
    );
    end component;

    component  v6_gthwizard_v1_11_caui_PULSE_SYNCHRONIZER
    port
    (
        SRCCLK_IN               : in  std_logic;
        DSTCLK_IN               : in  std_logic;
        SRCPULSE_IN             : in  std_logic;
        PULSETYPE_IN            : in  std_logic;
        DSTPULSE_OUT            : out std_logic
    );    
    end component;
 

--***********************************Parameter Declarations********************
    constant DLY : time := 1 ns;
--**************************** Signal Declarations ****************************

    -- ground and tied_to_vcc_i signals
    signal  tied_to_ground_i                :   std_logic;
    signal  tied_to_ground_vec_i            :   std_logic_vector(63 downto 0);
    signal  tied_to_vcc_i                   :   std_logic;

  
    -- RX Datapath signals
    signal rxdata0_i               :   std_logic_vector(63 downto 0);
 
 
    -- TX Datapath signals
    signal txdata0_i               :   std_logic_vector(63 downto 0);
 
  
    -- RX Datapath signals
    signal rxdata1_i               :   std_logic_vector(63 downto 0);
 
 
    -- TX Datapath signals
    signal txdata1_i               :   std_logic_vector(63 downto 0);
 
  
    -- RX Datapath signals
    signal rxdata2_i               :   std_logic_vector(63 downto 0);
 
 
    -- TX Datapath signals
    signal txdata2_i               :   std_logic_vector(63 downto 0);
 
  
    -- RX Datapath signals
    signal rxdata3_i               :   std_logic_vector(63 downto 0);
 
 
    -- TX Datapath signals
    signal txdata3_i               :   std_logic_vector(63 downto 0);
 

    -- INIT/RESET Module signals
    signal    init_gthreset0_i          :   std_logic;
    signal    init_resetdone0_i          :   std_logic;
    signal    not_init_resetdone0_i      :   std_logic;
 
    signal    init_txpowerdown0_i        :   std_logic;
    signal    init_txbufreset0_i         :   std_logic;
    signal    txpowerdown0_i             :   std_logic_vector(1 downto 0);
    signal    txbufreset0_i              :   std_logic;
    signal    txctrlack0_i               :   std_logic;
    signal    tx_pcs_reset0_i            :   std_logic;
    signal    pcs_txbufreset0_i          :   std_logic;
    signal    pcs_txpowerdown0_i         :   std_logic;
    signal    tx_pcs_reset_done0_i       :   std_logic;
 
 
    signal    init_rxpowerdown0_i        :   std_logic;
    signal    init_rxbufreset0_i         :   std_logic;     
    signal    init_rxbufreset0_r         :   std_logic;     
    signal    rxpowerdown0_i             :   std_logic_vector(1 downto 0);    
    signal    rxbufreset0_i              :   std_logic;
    signal    rxctrlack0_i               :   std_logic;
    signal    pcs_rxbufreset0_i          :   std_logic;
    signal    pcs_rxbufreset0_r          :   std_logic;
    signal    pcs_rxpowerdown0_i         :   std_logic;
    signal    rx_pcs_cdr_reset_done0_i   :   std_logic;
    signal    rxbufreset0_txuserclk_domain_i   :   std_logic;
 
    signal    init_gthreset1_i          :   std_logic;
    signal    init_resetdone1_i          :   std_logic;
    signal    not_init_resetdone1_i      :   std_logic;
 
    signal    init_txpowerdown1_i        :   std_logic;
    signal    init_txbufreset1_i         :   std_logic;
    signal    txpowerdown1_i             :   std_logic_vector(1 downto 0);
    signal    txbufreset1_i              :   std_logic;
    signal    txctrlack1_i               :   std_logic;
    signal    tx_pcs_reset1_i            :   std_logic;
    signal    pcs_txbufreset1_i          :   std_logic;
    signal    pcs_txpowerdown1_i         :   std_logic;
    signal    tx_pcs_reset_done1_i       :   std_logic;
 
 
    signal    init_rxpowerdown1_i        :   std_logic;
    signal    init_rxbufreset1_i         :   std_logic;     
    signal    init_rxbufreset1_r         :   std_logic;     
    signal    rxpowerdown1_i             :   std_logic_vector(1 downto 0);    
    signal    rxbufreset1_i              :   std_logic;
    signal    rxctrlack1_i               :   std_logic;
    signal    pcs_rxbufreset1_i          :   std_logic;
    signal    pcs_rxbufreset1_r          :   std_logic;
    signal    pcs_rxpowerdown1_i         :   std_logic;
    signal    rx_pcs_cdr_reset_done1_i   :   std_logic;
    signal    rxbufreset1_txuserclk_domain_i   :   std_logic;
 
    signal    init_gthreset2_i          :   std_logic;
    signal    init_resetdone2_i          :   std_logic;
    signal    not_init_resetdone2_i      :   std_logic;
 
    signal    init_txpowerdown2_i        :   std_logic;
    signal    init_txbufreset2_i         :   std_logic;
    signal    txpowerdown2_i             :   std_logic_vector(1 downto 0);
    signal    txbufreset2_i              :   std_logic;
    signal    txctrlack2_i               :   std_logic;
    signal    tx_pcs_reset2_i            :   std_logic;
    signal    pcs_txbufreset2_i          :   std_logic;
    signal    pcs_txpowerdown2_i         :   std_logic;
    signal    tx_pcs_reset_done2_i       :   std_logic;
 
 
    signal    init_rxpowerdown2_i        :   std_logic;
    signal    init_rxbufreset2_i         :   std_logic;     
    signal    init_rxbufreset2_r         :   std_logic;     
    signal    rxpowerdown2_i             :   std_logic_vector(1 downto 0);    
    signal    rxbufreset2_i              :   std_logic;
    signal    rxctrlack2_i               :   std_logic;
    signal    pcs_rxbufreset2_i          :   std_logic;
    signal    pcs_rxbufreset2_r          :   std_logic;
    signal    pcs_rxpowerdown2_i         :   std_logic;
    signal    rx_pcs_cdr_reset_done2_i   :   std_logic;
    signal    rxbufreset2_txuserclk_domain_i   :   std_logic;
 
    signal    init_gthreset3_i          :   std_logic;
    signal    init_resetdone3_i          :   std_logic;
    signal    not_init_resetdone3_i      :   std_logic;
 
    signal    init_txpowerdown3_i        :   std_logic;
    signal    init_txbufreset3_i         :   std_logic;
    signal    txpowerdown3_i             :   std_logic_vector(1 downto 0);
    signal    txbufreset3_i              :   std_logic;
    signal    txctrlack3_i               :   std_logic;
    signal    tx_pcs_reset3_i            :   std_logic;
    signal    pcs_txbufreset3_i          :   std_logic;
    signal    pcs_txpowerdown3_i         :   std_logic;
    signal    tx_pcs_reset_done3_i       :   std_logic;
 
 
    signal    init_rxpowerdown3_i        :   std_logic;
    signal    init_rxbufreset3_i         :   std_logic;     
    signal    init_rxbufreset3_r         :   std_logic;     
    signal    rxpowerdown3_i             :   std_logic_vector(1 downto 0);    
    signal    rxbufreset3_i              :   std_logic;
    signal    rxctrlack3_i               :   std_logic;
    signal    pcs_rxbufreset3_i          :   std_logic;
    signal    pcs_rxbufreset3_r          :   std_logic;
    signal    pcs_rxpowerdown3_i         :   std_logic;
    signal    rx_pcs_cdr_reset_done3_i   :   std_logic;
    signal    rxbufreset3_txuserclk_domain_i   :   std_logic;
 

    signal    gthinit_i                           :   std_logic;
    signal    gthinit_due_to_reset_i              :   std_logic;    
    signal    gthreset_i                          :   std_logic;
    signal    gth_initdone_i                      :   std_logic;
    signal    gthinitdone_i                       :   std_logic;
    signal    gthinitdone_b_i                     :   std_logic;
 
    signal    txctrlack_i                         :   std_logic;
 
 
    signal    rxctrlack_i                         :   std_logic;
    signal    GSR                                 :   std_logic;
    signal    ctrlack                             :   std_logic;
    signal    gthreset_rdy_i                      :   std_logic;

    signal    mgmtpcslanesel_i                    :   std_logic_vector(3 downto 0);
    signal    mgmtpcsmmdaddr_i                    :   std_logic_vector(4 downto 0);
    signal    mgmtpcsrdack_i                      :   std_logic;
    signal    mgmtpcsrddata_i                     :   std_logic_vector(15 downto 0);
    signal    mgmtpcsregaddr_i                    :   std_logic_vector(15 downto 0);
    signal    mgmtpcsregrd_i                      :   std_logic;
    signal    mgmtpcsregwr_i                      :   std_logic;
    signal    mgmtpcswrdata_i                     :   std_logic_vector(15 downto 0);
    signal    disable_drp_i                       :   std_logic;
    
    signal    mgmtpcslanesel_gt                   :   std_logic_vector(3 downto 0);
    signal    mgmtpcsmmdaddr_gt                   :   std_logic_vector(4 downto 0);
    signal    mgmtpcsrdack_gt                     :   std_logic;
    signal    mgmtpcsrddata_gt                    :   std_logic_vector(15 downto 0);
    signal    mgmtpcsregaddr_gt                   :   std_logic_vector(15 downto 0);
    signal    mgmtpcsregrd_gt                     :   std_logic;
    signal    mgmtpcsregwr_gt                     :   std_logic;
    signal    mgmtpcswrdata_gt                    :   std_logic_vector(15 downto 0);
    signal    disable_drp_gt                      :   std_logic;
    
--***************************** Reg Declarations ******************************

    -- synthesis attribute shreg_extract of por_r is no
    signal    por_r                               :   std_logic_vector(1 downto 0); --/* synthesis syn_srlstyle = "registers" */ ;
  
    signal    txctrlack_r                         :   std_logic;
    signal    txctrlack_r2                        :   std_logic;    
 
 
    signal    rxctrlack_r                         :   std_logic;   
    signal    rxctrlack_r2                        :   std_logic; 
   
    signal    gthreset_rdy_r                      :   std_logic;
    signal    gthreset_rdy_r2                     :   std_logic;  
 
    -- synthesis attribute shreg_extract of rx_sync_reset0_r is no
 
    signal    rx_sync_reset0_r                    :   std_logic_vector(1 downto 0); --/* synthesis syn_srlstyle = "registers" */ ; 
    signal    rxbufreset0_r                       :   std_logic := '0'; 
    signal    rxbufreset0_r2                      :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done0_r            :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done0_r2           :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done0_tx_clk_r     :   std_logic;
    signal    rx_pcs_cdr_reset_done0_tx_clk_r2    :   std_logic;
    signal    rx_pcs_cdr_reset_done0_tx_clk_r3    :   std_logic;
    signal    rx_pcs_cdr_reset0_r                 :   std_logic;
    signal    rx_pcs_cdr_reset0_r2                :   std_logic;  
  
    signal    sync_reset0_r                       :   std_logic;    
 
    -- synthesis attribute shreg_extract of rx_sync_reset1_r is no
 
    signal    rx_sync_reset1_r                    :   std_logic_vector(1 downto 0); --/* synthesis syn_srlstyle = "registers" */ ; 
    signal    rxbufreset1_r                       :   std_logic := '0'; 
    signal    rxbufreset1_r2                      :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done1_r            :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done1_r2           :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done1_tx_clk_r     :   std_logic;
    signal    rx_pcs_cdr_reset_done1_tx_clk_r2    :   std_logic;
    signal    rx_pcs_cdr_reset_done1_tx_clk_r3    :   std_logic;
    signal    rx_pcs_cdr_reset1_r                 :   std_logic;
    signal    rx_pcs_cdr_reset1_r2                :   std_logic;  
  
    signal    sync_reset1_r                       :   std_logic;    
 
    -- synthesis attribute shreg_extract of rx_sync_reset2_r is no
 
    signal    rx_sync_reset2_r                    :   std_logic_vector(1 downto 0); --/* synthesis syn_srlstyle = "registers" */ ; 
    signal    rxbufreset2_r                       :   std_logic := '0'; 
    signal    rxbufreset2_r2                      :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done2_r            :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done2_r2           :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done2_tx_clk_r     :   std_logic;
    signal    rx_pcs_cdr_reset_done2_tx_clk_r2    :   std_logic;
    signal    rx_pcs_cdr_reset_done2_tx_clk_r3    :   std_logic;
    signal    rx_pcs_cdr_reset2_r                 :   std_logic;
    signal    rx_pcs_cdr_reset2_r2                :   std_logic;  
  
    signal    sync_reset2_r                       :   std_logic;    
 
    -- synthesis attribute shreg_extract of rx_sync_reset3_r is no
 
    signal    rx_sync_reset3_r                    :   std_logic_vector(1 downto 0); --/* synthesis syn_srlstyle = "registers" */ ; 
    signal    rxbufreset3_r                       :   std_logic := '0'; 
    signal    rxbufreset3_r2                      :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done3_r            :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done3_r2           :   std_logic := '0';
    signal    rx_pcs_cdr_reset_done3_tx_clk_r     :   std_logic;
    signal    rx_pcs_cdr_reset_done3_tx_clk_r2    :   std_logic;
    signal    rx_pcs_cdr_reset_done3_tx_clk_r3    :   std_logic;
    signal    rx_pcs_cdr_reset3_r                 :   std_logic;
    signal    rx_pcs_cdr_reset3_r2                :   std_logic;  
  
    signal    sync_reset3_r                       :   std_logic;    

    attribute ASYNC_REG                           : string;
    attribute ASYNC_REG of sync_reset0_r : signal is "TRUE";
    attribute ASYNC_REG of sync_reset1_r : signal is "TRUE";
    attribute ASYNC_REG of sync_reset2_r : signal is "TRUE";
    attribute ASYNC_REG of sync_reset3_r : signal is "TRUE";

begin
--******************************** Main Body of Code***************************

    ---------------------------  Static signal Assignments ---------------------   

    tied_to_ground_i                    <= '0';
    tied_to_ground_vec_i(63 downto 0)   <= (others => '0');
    tied_to_vcc_i                       <= '1';
    GTHINITDONE_OUT                     <= gthinitdone_i;

    mgmt_intf_sel: process(gthinitdone_i,mgmtpcslanesel_i,mgmtpcsmmdaddr_i,mgmtpcsregaddr_i,mgmtpcsregrd_i,mgmtpcsregwr_i,mgmtpcswrdata_i,disable_drp_i,mgmtpcsrdack_gt,mgmtpcsrddata_gt,MGMTPCSLANESEL_IN,MGMTPCSMMDADDR_IN,MGMTPCSREGADDR_IN,MGMTPCSREGRD_IN,MGMTPCSREGWR_IN,MGMTPCSWRDATA_IN,DISABLEDRP_IN)
    begin
        if(gthinitdone_i='0') then
           mgmtpcslanesel_gt <= mgmtpcslanesel_i;
           mgmtpcsmmdaddr_gt <= mgmtpcsmmdaddr_i;
           mgmtpcsregaddr_gt <= mgmtpcsregaddr_i;
           mgmtpcsregrd_gt   <= mgmtpcsregrd_i  ;
           mgmtpcsregwr_gt   <= mgmtpcsregwr_i  ;
           mgmtpcswrdata_gt  <= mgmtpcswrdata_i ;
           disable_drp_gt    <= disable_drp_i   ;
           MGMTPCSRDACK_OUT  <= '0'             ;
           MGMTPCSRDDATA_OUT <= (others => '0') ;
           mgmtpcsrdack_i    <= mgmtpcsrdack_gt ;
           mgmtpcsrddata_i   <= mgmtpcsrddata_gt;
        else
           mgmtpcslanesel_gt <= MGMTPCSLANESEL_IN;
           mgmtpcsmmdaddr_gt <= MGMTPCSMMDADDR_IN;
           mgmtpcsregaddr_gt <= MGMTPCSREGADDR_IN;
           mgmtpcsregrd_gt   <= MGMTPCSREGRD_IN  ;
           mgmtpcsregwr_gt   <= MGMTPCSREGWR_IN  ;
           mgmtpcswrdata_gt  <= MGMTPCSWRDATA_IN ;
           disable_drp_gt    <= DISABLEDRP_IN    ;
           MGMTPCSRDACK_OUT  <= mgmtpcsrdack_gt  ;
           MGMTPCSRDDATA_OUT <= mgmtpcsrddata_gt ;
           mgmtpcsrdack_i    <= '0'              ;
           mgmtpcsrddata_i   <= (others => '0')  ;
        end if;
    end process;    

 



    RXDATA0_OUT    <=   rxdata0_i(63 downto 0);
     

    txdata0_i    <=   TXDATA0_IN;
 



    RXDATA1_OUT    <=   rxdata1_i(63 downto 0);
     

    txdata1_i    <=   TXDATA1_IN;
 



    RXDATA2_OUT    <=   rxdata2_i(63 downto 0);
     

    txdata2_i    <=   TXDATA2_IN;
 



    RXDATA3_OUT    <=   rxdata3_i(63 downto 0);
     

    txdata3_i    <=   TXDATA3_IN;
    



    -------------------------- GTHE1_QUAD Instantiation  -----------------------  
    gthe1_quad_i :GTHE1_QUAD
    generic map
    (
        --_______________________ Simulation-Only Attributes ___________________
        SIM_VERSION                =>      ("1.0"),
        SIM_GTHRESET_SPEEDUP       =>      (QUAD_SIM_GTHRESET_SPEEDUP),

           ---------------------------- Other ----------------------------
            TX_FABRIC_WIDTH0                        =>     (64),
            TX_FABRIC_WIDTH1                        =>     (64),
            TX_FABRIC_WIDTH2                        =>     (64),
            TX_FABRIC_WIDTH3                        =>     (64),
            RX_FABRIC_WIDTH0                        =>     (64),
            RX_FABRIC_WIDTH1                        =>     (64),
            RX_FABRIC_WIDTH2                        =>     (64),
            RX_FABRIC_WIDTH3                        =>     (64),
            MODE_CFG1                               =>     (x"0000"),
            MODE_CFG2                               =>     (x"0000"),
            MODE_CFG3                               =>     (x"0000"),
            MODE_CFG4                               =>     (x"0000"),
            MODE_CFG5                               =>     (x"0000"),
            MODE_CFG6                               =>     (x"0000"),
            MODE_CFG7                               =>     (x"0000"),
            GTH_CFG_PWRUP_LANE0                     =>     ('1'),
            GTH_CFG_PWRUP_LANE1                     =>     ('1'),
            GTH_CFG_PWRUP_LANE2                     =>     ('1'),
            GTH_CFG_PWRUP_LANE3                     =>     ('1'),
            TX_DISABLE_LANE0                        =>     (x"0000"),
            TX_DISABLE_LANE1                        =>     (x"0000"),
            TX_DISABLE_LANE2                        =>     (x"0000"),
            TX_DISABLE_LANE3                        =>     (x"0000"),
            TX_PREEMPH_LANE0                        =>     (x"00a1"),
            TX_PREEMPH_LANE1                        =>     (x"00a1"),
            TX_PREEMPH_LANE2                        =>     (x"00a1"),
            TX_PREEMPH_LANE3                        =>     (x"00a1"),
            LNK_TRN_COEFF_REQ_LANE0                 =>     (x"0000"),
            LNK_TRN_COEFF_REQ_LANE1                 =>     (x"0000"),
            LNK_TRN_COEFF_REQ_LANE2                 =>     (x"0000"),
            LNK_TRN_COEFF_REQ_LANE3                 =>     (x"0000"),

           ---------------------------- PMA ----------------------------
            DLL_CFG0                                =>     (x"8202"),
            DLL_CFG1                                =>     (x"0000"),
            PMA_CTRL1_LANE0                         =>     (x"0000"),
            PMA_CTRL1_LANE1                         =>     (x"0000"),
            PMA_CTRL1_LANE2                         =>     (x"0000"),
            PMA_CTRL1_LANE3                         =>     (x"0000"),
            PMA_CTRL2_LANE0                         =>     (x"000b"),
            PMA_CTRL2_LANE1                         =>     (x"000b"),
            PMA_CTRL2_LANE2                         =>     (x"000b"),
            PMA_CTRL2_LANE3                         =>     (x"000b"),
            E10GBASEKR_LD_COEFF_UPD_LANE0           =>     (x"0000"),
            E10GBASEKR_LD_COEFF_UPD_LANE1           =>     (x"0000"),
            E10GBASEKR_LD_COEFF_UPD_LANE2           =>     (x"0000"),
            E10GBASEKR_LD_COEFF_UPD_LANE3           =>     (x"0000"),
            E10GBASEKR_LP_COEFF_UPD_LANE0           =>     (x"0000"),
            E10GBASEKR_LP_COEFF_UPD_LANE1           =>     (x"0000"),
            E10GBASEKR_LP_COEFF_UPD_LANE2           =>     (x"0000"),
            E10GBASEKR_LP_COEFF_UPD_LANE3           =>     (x"0000"),
            E10GBASEKR_PMA_CTRL_LANE0               =>     (x"0002"),
            E10GBASEKR_PMA_CTRL_LANE1               =>     (x"0002"),
            E10GBASEKR_PMA_CTRL_LANE2               =>     (x"0002"),
            E10GBASEKR_PMA_CTRL_LANE3               =>     (x"0002"),
            E10GBASEKX_CTRL_LANE0                   =>     (x"0000"),
            E10GBASEKX_CTRL_LANE1                   =>     (x"0000"),
            E10GBASEKX_CTRL_LANE2                   =>     (x"0000"),
            E10GBASEKX_CTRL_LANE3                   =>     (x"0000"),
            GLBL_AMON_SEL                           =>     (x"0000"),
            GLBL_DMON_SEL                           =>     (x"0200"),
            GLBL_PWR_CTRL                           =>     (x"0000"),
            GLBL0_NOISE_CTRL                        =>     (x"f0b8"),
--            LANE_AMON_SEL                           =>     (x"00f0"),
-- PMA loopback!
            LANE_AMON_SEL                           =>     (x"0100"),
            LANE_DMON_SEL                           =>     (x"0000"),
            LANE_LNK_CFGOVRD                        =>     (x"0000"),
            LANE_PWR_CTRL_LANE0                     =>     (x"0400"),
            LANE_PWR_CTRL_LANE1                     =>     (x"0400"),
            LANE_PWR_CTRL_LANE2                     =>     (x"0400"),
            LANE_PWR_CTRL_LANE3                     =>     (x"0400"),
            LNK_TRN_CFG_LANE0                       =>     (x"0000"),
            LNK_TRN_CFG_LANE1                       =>     (x"0000"),
            LNK_TRN_CFG_LANE2                       =>     (x"0000"),
            LNK_TRN_CFG_LANE3                       =>     (x"0000"),
            MISC_CFG                                =>     (x"0008"),
            PLL_CFG0                                =>     (x"9fe0"),
            PLL_CFG1                                =>     (x"81C0"),
            PLL_CFG2                                =>     (x"0424"),
--            PMA_LPBK_CTRL_LANE0                     =>     (x"0000"),
--            PMA_LPBK_CTRL_LANE1                     =>     (x"0000"),
--            PMA_LPBK_CTRL_LANE2                     =>     (x"0000"),
--            PMA_LPBK_CTRL_LANE3                     =>     (x"0000"),
-- PMA loopback!
            PMA_LPBK_CTRL_LANE0                     =>     (x"0002"),
            PMA_LPBK_CTRL_LANE1                     =>     (x"0002"),
            PMA_LPBK_CTRL_LANE2                     =>     (x"0002"),
            PMA_LPBK_CTRL_LANE3                     =>     (x"0002"),

            PWRUP_DLY                               =>     (x"0000"),
            DFE_TRAIN_CTRL_LANE0                    =>     ("0100001111010000"),
            DFE_TRAIN_CTRL_LANE1                    =>     ("0100001111010000"),
            DFE_TRAIN_CTRL_LANE2                    =>     ("0100001111010000"),
            DFE_TRAIN_CTRL_LANE3                    =>     ("0100001111010000"),
            RX_AEQ_VAL0_LANE0                       =>     (x"03C0"),
            RX_AEQ_VAL0_LANE1                       =>     (x"03C0"),
            RX_AEQ_VAL0_LANE2                       =>     (x"03C0"),
            RX_AEQ_VAL0_LANE3                       =>     (x"03C0"),
            RX_AEQ_VAL1_LANE0                       =>     (x"0000"),
            RX_AEQ_VAL1_LANE1                       =>     (x"0000"),
            RX_AEQ_VAL1_LANE2                       =>     (x"0000"),
            RX_AEQ_VAL1_LANE3                       =>     (x"0000"),
            RX_AGC_CTRL_LANE0                       =>     (x"0000"),
            RX_AGC_CTRL_LANE1                       =>     (x"0000"),
            RX_AGC_CTRL_LANE2                       =>     (x"0000"),
            RX_AGC_CTRL_LANE3                       =>     (x"0000"),
            RX_CDR_CTRL0_LANE0                      =>     (x"0005"),
            RX_CDR_CTRL0_LANE1                      =>     (x"0005"),
            RX_CDR_CTRL0_LANE2                      =>     (x"0005"),
            RX_CDR_CTRL0_LANE3                      =>     (x"0005"),
            RX_CDR_CTRL1_LANE0                      =>     (x"4200"),
            RX_CDR_CTRL1_LANE1                      =>     (x"4200"),
            RX_CDR_CTRL1_LANE2                      =>     (x"4200"),
            RX_CDR_CTRL1_LANE3                      =>     (x"4200"),
            RX_CDR_CTRL2_LANE0                      =>     (x"2000"),
            RX_CDR_CTRL2_LANE1                      =>     (x"2000"),
            RX_CDR_CTRL2_LANE2                      =>     (x"2000"),
            RX_CDR_CTRL2_LANE3                      =>     (x"2000"),
            RX_CFG0_LANE0                           =>     (x"0500"),
            RX_CFG0_LANE1                           =>     (x"0500"),
            RX_CFG0_LANE2                           =>     (x"0500"),
            RX_CFG0_LANE3                           =>     (x"0500"),
            RX_CFG1_LANE0                           =>     (x"821f"),
            RX_CFG1_LANE1                           =>     (x"821f"),
            RX_CFG1_LANE2                           =>     (x"821f"),
            RX_CFG1_LANE3                           =>     (x"821f"),
            RX_CFG2_LANE0                           =>     (x"1001"),
            RX_CFG2_LANE1                           =>     (x"1001"),
            RX_CFG2_LANE2                           =>     (x"1001"),
            RX_CFG2_LANE3                           =>     (x"1001"),
            RX_CTLE_CTRL_LANE0                      =>     (x"008f"),
            RX_CTLE_CTRL_LANE1                      =>     (x"008f"),
            RX_CTLE_CTRL_LANE2                      =>     (x"008f"),
            RX_CTLE_CTRL_LANE3                      =>     (x"008f"),
            RX_CTRL_OVRD_LANE0                      =>     (x"000c"),
            RX_CTRL_OVRD_LANE1                      =>     (x"000c"),
            RX_CTRL_OVRD_LANE2                      =>     (x"000c"),
            RX_CTRL_OVRD_LANE3                      =>     (x"000c"),
            RX_PI_CTRL0                             =>     (x"d2f0"),
            RX_PI_CTRL1                             =>     (x"0080"),
            TX_CFG0_LANE0                           =>     (x"203d"),
            TX_CFG0_LANE1                           =>     (x"203d"),
            TX_CFG0_LANE2                           =>     (x"203d"),
            TX_CFG0_LANE3                           =>     (x"203d"),
            TX_CFG1_LANE0                           =>     (x"0F00"),
            TX_CFG1_LANE1                           =>     (x"0F00"),
            TX_CFG1_LANE2                           =>     (x"0F00"),
            TX_CFG1_LANE3                           =>     (x"0F00"),
            TX_CFG2_LANE0                           =>     (x"0081"),
            TX_CFG2_LANE1                           =>     (x"0081"),
            TX_CFG2_LANE2                           =>     (x"0081"),
            TX_CFG2_LANE3                           =>     (x"0081"),
            TX_CLK_SEL0_LANE0                       =>     (x"2121"),
            TX_CLK_SEL0_LANE1                       =>     (x"2121"),
            TX_CLK_SEL0_LANE2                       =>     (x"2121"),
            TX_CLK_SEL0_LANE3                       =>     (x"2121"),
            TX_CLK_SEL1_LANE0                       =>     (x"2121"),
            TX_CLK_SEL1_LANE1                       =>     (x"2121"),
            TX_CLK_SEL1_LANE2                       =>     (x"2121"),
            TX_CLK_SEL1_LANE3                       =>     (x"2121"),
--            SLICE_CFG                               =>     (x"0000"),
-- PMA loopback!
            SLICE_CFG                               =>     (x"0003"),
            SLICE_NOISE_CTRL_0_LANE01               =>     (x"0000"),
            SLICE_NOISE_CTRL_0_LANE23               =>     (x"0000"),
            SLICE_NOISE_CTRL_1_LANE01               =>     (x"0000"),
            SLICE_NOISE_CTRL_1_LANE23               =>     (x"0000"),
            SLICE_NOISE_CTRL_2_LANE01               =>     (x"7FFF"),
            SLICE_NOISE_CTRL_2_LANE23               =>     (x"7FFF"),
            SLICE_TX_RESET_LANE01                   =>     (x"0000"),
            SLICE_TX_RESET_LANE23                   =>     (x"0000"),
            TERM_CTRL_LANE0                         =>     (x"5007"),
            TERM_CTRL_LANE1                         =>     (x"5007"),
            TERM_CTRL_LANE2                         =>     (x"5007"),
            TERM_CTRL_LANE3                         =>     (x"5007"),
            TX_PWR_RATE_OVRD_LANE0                  =>     (x"0060"),
            TX_PWR_RATE_OVRD_LANE1                  =>     (x"0060"),
            TX_PWR_RATE_OVRD_LANE2                  =>     (x"0060"),
            TX_PWR_RATE_OVRD_LANE3                  =>     (x"0060"),
            TX_P1P2_CTRL                            =>     (x"0c39"),
            TX_P0P0S_CTRL                           =>     (x"060c"),
            RX_P1_CTRL                              =>     (x"1216"),
            RX_P2_CTRL                              =>     (x"0e0f"),
            RX_P0S_CTRL                             =>     (x"1206"),
            RX_P0_CTRL                              =>     (x"11f0"),
            RX_MVAL0_LANE0                          =>     (x"0000"),
            RX_MVAL0_LANE1                          =>     (x"0000"),
            RX_MVAL0_LANE2                          =>     (x"0000"),
            RX_MVAL0_LANE3                          =>     (x"0000"),
            RX_MVAL1_LANE0                          =>     (x"0000"),
            RX_MVAL1_LANE1                          =>     (x"0000"),
            RX_MVAL1_LANE2                          =>     (x"0000"),
            RX_MVAL1_LANE3                          =>     (x"0000"),
            RX_LOOP_CTRL_LANE0                      =>     (x"007F"),
            RX_LOOP_CTRL_LANE1                      =>     (x"007F"),
            RX_LOOP_CTRL_LANE2                      =>     (x"007F"),
            RX_LOOP_CTRL_LANE3                      =>     (x"007F"),

           ---------------------------- PCS ----------------------------
            BER_CONST_PTRN0                         =>     (x"0000"),
            BER_CONST_PTRN1                         =>     (x"0000"),
            BUFFER_CONFIG_LANE0                     =>     (x"3A80"),
            BUFFER_CONFIG_LANE1                     =>     (x"3A80"),
            BUFFER_CONFIG_LANE2                     =>     (x"3A80"),
            BUFFER_CONFIG_LANE3                     =>     (x"3A80"),
            E10GBASER_PCS_CFG_LANE0                 =>     (x"070c"),
            E10GBASER_PCS_CFG_LANE1                 =>     (x"070c"),
            E10GBASER_PCS_CFG_LANE2                 =>     (x"070c"),
            E10GBASER_PCS_CFG_LANE3                 =>     (x"070c"),
            E10GBASER_PCS_SEEDA0_LANE0              =>     (x"0001"),
            E10GBASER_PCS_SEEDA0_LANE1              =>     (x"0001"),
            E10GBASER_PCS_SEEDA0_LANE2              =>     (x"0001"),
            E10GBASER_PCS_SEEDA0_LANE3              =>     (x"0001"),
            E10GBASER_PCS_SEEDA1_LANE0              =>     (x"0000"),
            E10GBASER_PCS_SEEDA1_LANE1              =>     (x"0000"),
            E10GBASER_PCS_SEEDA1_LANE2              =>     (x"0000"),
            E10GBASER_PCS_SEEDA1_LANE3              =>     (x"0000"),
            E10GBASER_PCS_SEEDA2_LANE0              =>     (x"0000"),
            E10GBASER_PCS_SEEDA2_LANE1              =>     (x"0000"),
            E10GBASER_PCS_SEEDA2_LANE2              =>     (x"0000"),
            E10GBASER_PCS_SEEDA2_LANE3              =>     (x"0000"),
            E10GBASER_PCS_SEEDA3_LANE0              =>     (x"0000"),
            E10GBASER_PCS_SEEDA3_LANE1              =>     (x"0000"),
            E10GBASER_PCS_SEEDA3_LANE2              =>     (x"0000"),
            E10GBASER_PCS_SEEDA3_LANE3              =>     (x"0000"),
            E10GBASER_PCS_SEEDB0_LANE0              =>     (x"0001"),
            E10GBASER_PCS_SEEDB0_LANE1              =>     (x"0001"),
            E10GBASER_PCS_SEEDB0_LANE2              =>     (x"0001"),
            E10GBASER_PCS_SEEDB0_LANE3              =>     (x"0001"),
            E10GBASER_PCS_SEEDB1_LANE0              =>     (x"0000"),
            E10GBASER_PCS_SEEDB1_LANE1              =>     (x"0000"),
            E10GBASER_PCS_SEEDB1_LANE2              =>     (x"0000"),
            E10GBASER_PCS_SEEDB1_LANE3              =>     (x"0000"),
            E10GBASER_PCS_SEEDB2_LANE0              =>     (x"0000"),
            E10GBASER_PCS_SEEDB2_LANE1              =>     (x"0000"),
            E10GBASER_PCS_SEEDB2_LANE2              =>     (x"0000"),
            E10GBASER_PCS_SEEDB2_LANE3              =>     (x"0000"),
            E10GBASER_PCS_SEEDB3_LANE0              =>     (x"0000"),
            E10GBASER_PCS_SEEDB3_LANE1              =>     (x"0000"),
            E10GBASER_PCS_SEEDB3_LANE2              =>     (x"0000"),
            E10GBASER_PCS_SEEDB3_LANE3              =>     (x"0000"),
            E10GBASER_PCS_TEST_CTRL_LANE0           =>     (x"0000"),
            E10GBASER_PCS_TEST_CTRL_LANE1           =>     (x"0000"),
            E10GBASER_PCS_TEST_CTRL_LANE2           =>     (x"0000"),
            E10GBASER_PCS_TEST_CTRL_LANE3           =>     (x"0000"),
            E10GBASEX_PCS_TSTCTRL_LANE0             =>     (x"0000"),
            E10GBASEX_PCS_TSTCTRL_LANE1             =>     (x"0000"),
            E10GBASEX_PCS_TSTCTRL_LANE2             =>     (x"0000"),
            E10GBASEX_PCS_TSTCTRL_LANE3             =>     (x"0000"),
            PCS_ABILITY_LANE0                       =>     (x"0010"),
            PCS_ABILITY_LANE1                       =>     (x"0010"),
            PCS_ABILITY_LANE2                       =>     (x"0010"),
            PCS_ABILITY_LANE3                       =>     (x"0010"),
            PCS_CTRL1_LANE0                         =>     (x"2040"),
            PCS_CTRL1_LANE1                         =>     (x"2040"),
            PCS_CTRL1_LANE2                         =>     (x"2040"),
            PCS_CTRL1_LANE3                         =>     (x"2040"),
            PCS_CTRL2_LANE0                         =>     (x"0000"),
            PCS_CTRL2_LANE1                         =>     (x"0000"),
            PCS_CTRL2_LANE2                         =>     (x"0000"),
            PCS_CTRL2_LANE3                         =>     (x"0000"),
            PCS_MISC_CFG_0_LANE0                    =>     (x"1916"), --(x"1116"), -- 9 = invert Tx polarity
            PCS_MISC_CFG_0_LANE1                    =>     (x"1916"), --(x"1116"), -- 9 = invert Tx polarity
            PCS_MISC_CFG_0_LANE2                    =>     (x"1916"), --(x"1116"), -- 9 = invert Tx polarity
            PCS_MISC_CFG_0_LANE3                    =>     (x"1916"), --(x"1116"), -- 9 = invert Tx polarity
            PCS_MISC_CFG_1_LANE0                    =>     (x"0000"),
            PCS_MISC_CFG_1_LANE1                    =>     (x"0000"),
            PCS_MISC_CFG_1_LANE2                    =>     (x"0000"),
            PCS_MISC_CFG_1_LANE3                    =>     (x"0000"),
            PCS_MODE_LANE0                          =>     (x"00AA"),
            PCS_MODE_LANE1                          =>     (x"00AA"),
            PCS_MODE_LANE2                          =>     (x"00AA"),
            PCS_MODE_LANE3                          =>     (x"00AA"),
            PCS_RESET_LANE0                         =>     (x"FF3B"),
            PCS_RESET_LANE1                         =>     (x"FF3B"),
            PCS_RESET_LANE2                         =>     (x"FF3B"),
            PCS_RESET_LANE3                         =>     (x"FF3B"),
            PCS_TYPE_LANE0                          =>     (x"002c"),
            PCS_TYPE_LANE1                          =>     (x"002c"),
            PCS_TYPE_LANE2                          =>     (x"002c"),
            PCS_TYPE_LANE3                          =>     (x"002c"),
            PRBS_BER_CFG0_LANE0                     =>     (x"0000"),
            PRBS_BER_CFG0_LANE1                     =>     (x"0000"),
            PRBS_BER_CFG0_LANE2                     =>     (x"0000"),
            PRBS_BER_CFG0_LANE3                     =>     (x"0000"),
            PRBS_BER_CFG1_LANE0                     =>     (x"0000"),
            PRBS_BER_CFG1_LANE1                     =>     (x"0000"),
            PRBS_BER_CFG1_LANE2                     =>     (x"0000"),
            PRBS_BER_CFG1_LANE3                     =>     (x"0000"),
            PRBS_CFG_LANE0                          =>     (x"000a"),
            PRBS_CFG_LANE1                          =>     (x"000a"),
            PRBS_CFG_LANE2                          =>     (x"000a"),
            PRBS_CFG_LANE3                          =>     (x"000a"),
            PTRN_CFG0_LSB                           =>     (x"5555"),
            PTRN_CFG0_MSB                           =>     (x"5555"),
            PTRN_LEN_CFG                            =>     (x"001f"),
            PCS_RESET_1_LANE0                       =>     (x"0000"),
            PCS_RESET_1_LANE1                       =>     (x"0000"),
            PCS_RESET_1_LANE2                       =>     (x"0000"),
            PCS_RESET_1_LANE3                       =>     (x"0000")

     )
     port map
     (
 
 
 
 
 
 
 
 
        ------------------------------------ DFE -----------------------------------
        DFETRAINCTRL0                   =>      tied_to_ground_i,
        DFETRAINCTRL1                   =>      tied_to_ground_i,
        DFETRAINCTRL2                   =>      tied_to_ground_i,
        DFETRAINCTRL3                   =>      tied_to_ground_i,
        --------------------------------- Powerdown --------------------------------
        POWERDOWN0                      =>      POWERDOWN0_IN,
        POWERDOWN1                      =>      POWERDOWN1_IN,
        POWERDOWN2                      =>      POWERDOWN2_IN,
        POWERDOWN3                      =>      POWERDOWN3_IN,
        RXPOWERDOWN0                    =>      rxpowerdown0_i,
        RXPOWERDOWN1                    =>      rxpowerdown1_i,
        RXPOWERDOWN2                    =>      rxpowerdown2_i,
        RXPOWERDOWN3                    =>      rxpowerdown3_i,
        TXPOWERDOWN0                    =>      txpowerdown0_i,
        TXPOWERDOWN1                    =>      txpowerdown1_i,
        TXPOWERDOWN2                    =>      txpowerdown2_i,
        TXPOWERDOWN3                    =>      txpowerdown3_i,
        ------------------------------- Receive Ports ------------------------------
        RXBUFRESET0                     =>      rxbufreset0_i,
        RXBUFRESET1                     =>      rxbufreset1_i,
        RXBUFRESET2                     =>      rxbufreset2_i,
        RXBUFRESET3                     =>      rxbufreset3_i,
        RXCODEERR0                      =>      open,
        RXCODEERR1                      =>      open,
        RXCODEERR2                      =>      open,
        RXCODEERR3                      =>      open,
        RXCTRL0                         =>      open,
        RXCTRL1                         =>      open,
        RXCTRL2                         =>      open,
        RXCTRL3                         =>      open,
        RXCTRLACK0                      =>      rxctrlack0_i,
        RXCTRLACK1                      =>      rxctrlack1_i,
        RXCTRLACK2                      =>      rxctrlack2_i,
        RXCTRLACK3                      =>      rxctrlack3_i,
        RXDATA0                         =>      rxdata0_i,
        RXDATA1                         =>      rxdata1_i,
        RXDATA2                         =>      rxdata2_i,
        RXDATA3                         =>      rxdata3_i,
        RXDATATAP0                      =>      open,
        RXDATATAP1                      =>      open,
        RXDATATAP2                      =>      open,
        RXDATATAP3                      =>      open,
        RXDISPERR0                      =>      open,
        RXDISPERR1                      =>      open,
        RXDISPERR2                      =>      open,
        RXDISPERR3                      =>      open,
        RXENCOMMADET0                   =>      tied_to_ground_i,
        RXENCOMMADET1                   =>      tied_to_ground_i,
        RXENCOMMADET2                   =>      tied_to_ground_i,
        RXENCOMMADET3                   =>      tied_to_ground_i,
        RXN0                            =>      RXN0_IN,
        RXN1                            =>      RXN1_IN,
        RXN2                            =>      RXN2_IN,
        RXN3                            =>      RXN3_IN,
        RXP0                            =>      RXP0_IN,
        RXP1                            =>      RXP1_IN,
        RXP2                            =>      RXP2_IN,
        RXP3                            =>      RXP3_IN,
        RXPCSCLKSMPL0                   =>      open,
        RXPCSCLKSMPL1                   =>      open,
        RXPCSCLKSMPL2                   =>      open,
        RXPCSCLKSMPL3                   =>      open,
        RXPOLARITY0                     =>      tied_to_vcc_i, --tied_to_ground_i, --Invert RX polarity!
        RXPOLARITY1                     =>      tied_to_vcc_i, --tied_to_ground_i,
        RXPOLARITY2                     =>      tied_to_vcc_i, --tied_to_ground_i,
        RXPOLARITY3                     =>      tied_to_vcc_i, --tied_to_ground_i,
        RXRATE0                         =>      "00",
        RXRATE1                         =>      "00",
        RXRATE2                         =>      "00",
        RXRATE3                         =>      "00",
        RXSLIP0                         =>      RXSLIP0_IN,
        RXSLIP1                         =>      RXSLIP1_IN,
        RXSLIP2                         =>      RXSLIP2_IN,
        RXSLIP3                         =>      RXSLIP3_IN,
        RXUSERCLKIN0                    =>      RXUSERCLKIN0_IN,
        RXUSERCLKIN1                    =>      RXUSERCLKIN1_IN,
        RXUSERCLKIN2                    =>      RXUSERCLKIN2_IN,
        RXUSERCLKIN3                    =>      RXUSERCLKIN3_IN,
        RXUSERCLKOUT0                   =>      RXUSERCLKOUT0_OUT,
        RXUSERCLKOUT1                   =>      RXUSERCLKOUT1_OUT,
        RXUSERCLKOUT2                   =>      RXUSERCLKOUT2_OUT,
        RXUSERCLKOUT3                   =>      RXUSERCLKOUT3_OUT,
        RXVALID0                        =>      open,
        RXVALID1                        =>      open,
        RXVALID2                        =>      open,
        RXVALID3                        =>      open,
        ------------- Shared Ports - Dynamic Reconfiguration Port (DRP) ------------
        DADDR                           =>      DADDR_IN,
        DCLK                            =>      DCLK_IN,
        DEN                             =>      DEN_IN,
        DI                              =>      DI_IN,
        DISABLEDRP                      =>      disable_drp_gt,
        DRDY                            =>      DRDY_OUT,
        DRPDO                           =>      DRPDO_OUT,
        DWE                             =>      DWE_IN,
        ---------------------------- Shared Ports - Other --------------------------
        GTHX2LANE01                     =>      tied_to_ground_i,
        GTHX2LANE23                     =>      tied_to_ground_i,
        GTHX4LANE                       =>      tied_to_ground_i,
        PLLPCSCLKDIV                    =>      "000111",
        PLLREFCLKSEL                    =>      tied_to_ground_vec_i(2 downto 0),
        TSTPATH                         =>      open,
        TSTREFCLKFAB                    =>      open,
        TSTREFCLKOUT                    =>      GTH_REFCLK_OUT,
        GTHINIT                         =>      gthinit_i,
        GTHINITDONE                     =>      gth_initdone_i,
        GTHRESET                        =>      gthreset_i,
        MGMTPCSLANESEL                  =>      mgmtpcslanesel_gt,
        MGMTPCSMMDADDR                  =>      mgmtpcsmmdaddr_gt,
        MGMTPCSRDACK                    =>      mgmtpcsrdack_gt,
        MGMTPCSRDDATA                   =>      mgmtpcsrddata_gt,
        MGMTPCSREGADDR                  =>      mgmtpcsregaddr_gt,
        MGMTPCSREGRD                    =>      mgmtpcsregrd_gt,
        MGMTPCSREGWR                    =>      mgmtpcsregwr_gt,
        MGMTPCSWRDATA                   =>      mgmtpcswrdata_gt,
        REFCLK                          =>      REFCLK_IN,
        ------------------------------- Transmit Ports -----------------------------
        SAMPLERATE0                     =>      "000",
        SAMPLERATE1                     =>      "000",
        SAMPLERATE2                     =>      "000",
        SAMPLERATE3                     =>      "000",
        TXBUFRESET0                     =>      txbufreset0_i,
        TXBUFRESET1                     =>      txbufreset1_i,
        TXBUFRESET2                     =>      txbufreset2_i,
        TXBUFRESET3                     =>      txbufreset3_i,
        TXCTRL0                         =>      tied_to_ground_vec_i(7 downto 0),
        TXCTRL1                         =>      tied_to_ground_vec_i(7 downto 0),
        TXCTRL2                         =>      tied_to_ground_vec_i(7 downto 0),
        TXCTRL3                         =>      tied_to_ground_vec_i(7 downto 0),
        TXCTRLACK0                      =>      txctrlack0_i,
        TXCTRLACK1                      =>      txctrlack1_i,
        TXCTRLACK2                      =>      txctrlack2_i,
        TXCTRLACK3                      =>      txctrlack3_i,
        TXDATA0                         =>      txdata0_i,
        TXDATA1                         =>      txdata1_i,
        TXDATA2                         =>      txdata2_i,
        TXDATA3                         =>      txdata3_i,
        TXDATAMSB0                      =>      tied_to_ground_vec_i(7 downto 0),
        TXDATAMSB1                      =>      tied_to_ground_vec_i(7 downto 0),
        TXDATAMSB2                      =>      tied_to_ground_vec_i(7 downto 0),
        TXDATAMSB3                      =>      tied_to_ground_vec_i(7 downto 0),
        TXDATATAP10                     =>      open,
        TXDATATAP11                     =>      open,
        TXDATATAP12                     =>      open,
        TXDATATAP13                     =>      open,
        TXDATATAP20                     =>      open,
        TXDATATAP21                     =>      open,
        TXDATATAP22                     =>      open,
        TXDATATAP23                     =>      open,
        TXDEEMPH0                       =>      tied_to_ground_i,
        TXDEEMPH1                       =>      tied_to_ground_i,
        TXDEEMPH2                       =>      tied_to_ground_i,
        TXDEEMPH3                       =>      tied_to_ground_i,
        TXMARGIN0                       =>      tied_to_ground_vec_i(2 downto 0),
        TXMARGIN1                       =>      tied_to_ground_vec_i(2 downto 0),
        TXMARGIN2                       =>      tied_to_ground_vec_i(2 downto 0),
        TXMARGIN3                       =>      tied_to_ground_vec_i(2 downto 0),
        TXN0                            =>      TXN0_OUT,
        TXN1                            =>      TXN1_OUT,
        TXN2                            =>      TXN2_OUT,
        TXN3                            =>      TXN3_OUT,
        TXP0                            =>      TXP0_OUT,
        TXP1                            =>      TXP1_OUT,
        TXP2                            =>      TXP2_OUT,
        TXP3                            =>      TXP3_OUT,
        TXPCSCLKSMPL0                   =>      open,
        TXPCSCLKSMPL1                   =>      open,
        TXPCSCLKSMPL2                   =>      open,
        TXPCSCLKSMPL3                   =>      open,
        TXRATE0                         =>      "00",
        TXRATE1                         =>      "00",
        TXRATE2                         =>      "00",
        TXRATE3                         =>      "00",
        TXUSERCLKIN0                    =>      TXUSERCLKIN0_IN,
        TXUSERCLKIN1                    =>      TXUSERCLKIN1_IN,
        TXUSERCLKIN2                    =>      TXUSERCLKIN2_IN,
        TXUSERCLKIN3                    =>      TXUSERCLKIN3_IN,
        TXUSERCLKOUT0                   =>      TXUSERCLKOUT0_OUT,
        TXUSERCLKOUT1                   =>      TXUSERCLKOUT1_OUT,
        TXUSERCLKOUT2                   =>      TXUSERCLKOUT2_OUT,
        TXUSERCLKOUT3                   =>      TXUSERCLKOUT3_OUT

        );


    roc_i : ROC
    port map 
    (
        O => GSR
    );

    process(DCLK_IN, GSR)
    begin
        if (GSR = '1') then
            por_r <= "11";
        elsif (rising_edge(DCLK_IN)) then
            por_r <= '0' & por_r(1);
        end if;
    end process;

    gthinitdone_b_i <= not gthinitdone_i;
    
 
    process(RXUSERCLKIN0_IN, gthinitdone_b_i)
    begin
        if (gthinitdone_b_i = '1') then
            rx_sync_reset0_r <= "11" after DLY;
        elsif (rising_edge(RXUSERCLKIN0_IN)) then
            rx_sync_reset0_r  <= '0' & rx_sync_reset0_r(1) after DLY;
        end if;
    end process;

    process(RXUSERCLKIN0_IN)
    begin
        if (rising_edge(RXUSERCLKIN0_IN)) then
            sync_reset0_r <= rx_sync_reset0_r(0) after DLY;
        end if;
    end process;
 
 
    process(RXUSERCLKIN1_IN, gthinitdone_b_i)
    begin
        if (gthinitdone_b_i = '1') then
            rx_sync_reset1_r <= "11" after DLY;
        elsif (rising_edge(RXUSERCLKIN1_IN)) then
            rx_sync_reset1_r  <= '0' & rx_sync_reset1_r(1) after DLY;
        end if;
    end process;

    process(RXUSERCLKIN1_IN)
    begin
        if (rising_edge(RXUSERCLKIN1_IN)) then
            sync_reset1_r <= rx_sync_reset1_r(0) after DLY;
        end if;
    end process;
 
 
    process(RXUSERCLKIN2_IN, gthinitdone_b_i)
    begin
        if (gthinitdone_b_i = '1') then
            rx_sync_reset2_r <= "11" after DLY;
        elsif (rising_edge(RXUSERCLKIN2_IN)) then
            rx_sync_reset2_r  <= '0' & rx_sync_reset2_r(1) after DLY;
        end if;
    end process;

    process(RXUSERCLKIN2_IN)
    begin
        if (rising_edge(RXUSERCLKIN2_IN)) then
            sync_reset2_r <= rx_sync_reset2_r(0) after DLY;
        end if;
    end process;
 
 
    process(RXUSERCLKIN3_IN, gthinitdone_b_i)
    begin
        if (gthinitdone_b_i = '1') then
            rx_sync_reset3_r <= "11" after DLY;
        elsif (rising_edge(RXUSERCLKIN3_IN)) then
            rx_sync_reset3_r  <= '0' & rx_sync_reset3_r(1) after DLY;
        end if;
    end process;

    process(RXUSERCLKIN3_IN)
    begin
        if (rising_edge(RXUSERCLKIN3_IN)) then
            sync_reset3_r <= rx_sync_reset3_r(0) after DLY;
        end if;
    end process;
 
    
    
    ctrlack <= txctrlack_r2 or rxctrlack_r2;
 
 
    
    gth_reset_i : v6_gthwizard_v1_11_caui_GTH_RESET
    port map
    (
        DCLK_IN             => DCLK_IN,
        RESET_IN            => por_r(0),
        USER_GTHRESET_IN    => gthreset_rdy_r2,
        CTRLACK_IN          => ctrlack,
        MGMTPCSLANESEL_OUT  => mgmtpcslanesel_i,
        MGMTPCSMMDADDR_OUT  => mgmtpcsmmdaddr_i,
        MGMTPCSREGADDR_OUT  => mgmtpcsregaddr_i,
        MGMTPCSREGRD_OUT    => mgmtpcsregrd_i,
        MGMTPCSREGWR_OUT    => mgmtpcsregwr_i,
        MGMTPCSWRDATA_OUT   => mgmtpcswrdata_i,
        GTHINITDONE_IN      => gth_initdone_i,
        GTHINITDONE_OUT     => gthinitdone_i,
        MGMTPCSRDACK_IN     => mgmtpcsrdack_i,
        MGMTPCSRDDATA_IN    => mgmtpcsrddata_i,
        DISABLEDRP_OUT      => disable_drp_i,
        GTHRESET_OUT        => gthreset_i,
        GTHINIT_OUT         => gthinit_due_to_reset_i
    );
    
    gthinit_i <= gthinit_due_to_reset_i or GTHINIT_IN;

    gth0_init_i : v6_gthwizard_v1_11_caui_GTH_INIT
    generic map
    (
        FULL_RATE            =>      1,
        DIV_RATE             =>      "00"
    )
    port map
    (
        TXUSERCLK_IN         =>      TXUSERCLKIN0_IN,
        GTHRESET_IN          =>      GTHRESET_IN,
        GTHINITDONE_IN       =>      gthinitdone_i,
 
        TXCTRLACK_IN         =>      txctrlack0_i,
 
        RXCTRLACK_IN         =>      rxctrlack0_i,
        GTHRESET_OUT         =>      init_gthreset0_i,
 
        TXPOWERDOWN_OUT      =>      init_txpowerdown0_i,
 
        RXPOWERDOWN_OUT      =>      init_rxpowerdown0_i,
 
        TXBUFRESET_OUT       =>      init_txbufreset0_i,
 
        RXBUFRESET_OUT       =>      init_rxbufreset0_i,
 
        TXRATE_OUT           =>      open,
 
        RXRATE_OUT           =>      open,
  
        SAMPLERATE_OUT       =>      open,
        RESETDONE_OUT        =>      init_resetdone0_i
    );

    gth0_init_rxbufreset_sync_i : v6_gthwizard_v1_11_caui_PULSE_SYNCHRONIZER 
    port map
    (
        SRCCLK_IN           =>      TXUSERCLKIN0_IN,
        DSTCLK_IN           =>      RXUSERCLKIN0_IN,
        SRCPULSE_IN         =>      init_rxbufreset0_i,
        PULSETYPE_IN        =>      tied_to_ground_i,
        DSTPULSE_OUT        =>      init_rxbufreset0_r
    );
 
    not_init_resetdone0_i    <= not init_resetdone0_i;

 
    gth0_tx_pcs_reset_i : v6_gthwizard_v1_11_caui_GTH_TX_PCS_RESET
    port map
    (
        TXUSERCLK_IN        =>      TXUSERCLKIN0_IN,
        RESET_IN            =>      not_init_resetdone0_i,
        TXPCSRESET_IN       =>      tx_pcs_reset0_i,
        TXCTRLACK_IN        =>      txctrlack0_i,
        TXBUFRESET_OUT      =>      pcs_txbufreset0_i,
        TXPOWERDOWN_OUT     =>      pcs_txpowerdown0_i,
        TXPCSRESETDONE_OUT  =>      tx_pcs_reset_done0_i
    );
 

 
    RXCTRLACK0_OUT      <= rxctrlack0_i;

 
    TXCTRLACK0_OUT  <= txctrlack0_i;
    tx_pcs_reset0_i <= TX_PCS_RESET0_IN;

    TX_PCS_RESETDONE0_OUT <= tx_pcs_reset_done0_i;

    txpowerdown0_i(1) <= init_txpowerdown0_i or (tx_pcs_reset_done0_i and TXPOWERDOWN0_IN(1)) or pcs_txpowerdown0_i;
    txpowerdown0_i(0) <= '0';
    txbufreset0_i <= init_txbufreset0_i or (tx_pcs_reset_done0_i and TXBUFRESET0_IN) or pcs_txbufreset0_i;

 
    gth0_rx_pcs_cdr_reset_i : v6_gthwizard_v1_11_caui_GTH_RX_PCS_CDR_RESET
    port map
    (
        TXUSERCLK_IN            =>      TXUSERCLKIN0_IN,
        RESET_IN                =>      not_init_resetdone0_i,
        RXPCSRESET_IN           =>      rx_pcs_cdr_reset0_r2,
        RXCTRLACK_IN            =>      rxctrlack0_i,
        RXBUFRESET_OUT          =>      pcs_rxbufreset0_i,
        RXPOWERDOWN_OUT         =>      pcs_rxpowerdown0_i,
        RXPCSCDRRESETDONE_OUT   =>      rx_pcs_cdr_reset_done0_i
    );

    gth0_rx_pcs_rxbufreset_sync_i : v6_gthwizard_v1_11_caui_PULSE_SYNCHRONIZER 
    port map
    (
        SRCCLK_IN               =>      TXUSERCLKIN0_IN,
        DSTCLK_IN               =>      RXUSERCLKIN0_IN,
        SRCPULSE_IN             =>      pcs_rxbufreset0_i,
        PULSETYPE_IN            =>      tied_to_ground_i,
        DSTPULSE_OUT            =>      pcs_rxbufreset0_r
    );    

    process (TXUSERCLKIN0_IN)
    begin
        if (rising_edge(TXUSERCLKIN0_IN)) then
            if (not_init_resetdone0_i = '1') then        
                rx_pcs_cdr_reset0_r  <= '0' after DLY;
                rx_pcs_cdr_reset0_r2 <= '0' after DLY;        
            else
                rx_pcs_cdr_reset0_r  <= RX_PCS_CDR_RESET0_IN after DLY;
                rx_pcs_cdr_reset0_r2 <= rx_pcs_cdr_reset0_r after DLY;
            end if;
        end if;
    end process;

    RX_PCS_CDR_RESETDONE0_OUT  <= rx_pcs_cdr_reset_done0_r2;

    rxpowerdown0_i(1) <= init_rxpowerdown0_i or (rx_pcs_cdr_reset_done0_tx_clk_r3 and RXPOWERDOWN0_IN(1)) or pcs_rxpowerdown0_i;
    rxpowerdown0_i(0) <= '0';
    
    rxbufreset0_txuserclk_domain_i <= init_rxbufreset0_r or pcs_rxbufreset0_r;
    rxbufreset0_i <= rxbufreset0_r2 or (rx_pcs_cdr_reset_done0_r2 and RXBUFRESET0_IN);


 
    process (TXUSERCLKIN0_IN)
    begin
        if (rising_edge(TXUSERCLKIN0_IN)) then    
            if (not_init_resetdone0_i = '1') then
                rx_pcs_cdr_reset_done0_tx_clk_r  <= '0' after DLY;
                rx_pcs_cdr_reset_done0_tx_clk_r2 <= '0' after DLY;
                rx_pcs_cdr_reset_done0_tx_clk_r3 <= '0' after DLY;
            else
                rx_pcs_cdr_reset_done0_tx_clk_r  <= rx_pcs_cdr_reset_done0_i after DLY;
                rx_pcs_cdr_reset_done0_tx_clk_r2 <= rx_pcs_cdr_reset_done0_tx_clk_r after DLY;
                rx_pcs_cdr_reset_done0_tx_clk_r3 <= rx_pcs_cdr_reset_done0_tx_clk_r2 after DLY;
            end if;
        end if;
    end process;

    -- Double flop to RXUSERCLK domain
    process (RXUSERCLKIN0_IN)
    begin
        if (rising_edge(RXUSERCLKIN0_IN)) then
            if (sync_reset0_r = '1') then        
                rx_pcs_cdr_reset_done0_r  <= '0' after DLY;
                rx_pcs_cdr_reset_done0_r2 <= '0' after DLY;        
            else
                rx_pcs_cdr_reset_done0_r  <= rx_pcs_cdr_reset_done0_tx_clk_r3 after DLY;
                rx_pcs_cdr_reset_done0_r2 <= rx_pcs_cdr_reset_done0_r after DLY;
            end if;
        end if;
    end process;
    rxbufreset0_r2 <= rxbufreset0_txuserclk_domain_i;

  
    gth1_init_i : v6_gthwizard_v1_11_caui_GTH_INIT
    generic map
    (
        FULL_RATE            =>      1,
        DIV_RATE             =>      "00"
    )
    port map
    (
        TXUSERCLK_IN         =>      TXUSERCLKIN1_IN,
        GTHRESET_IN          =>      GTHRESET_IN,
        GTHINITDONE_IN       =>      gthinitdone_i,
 
        TXCTRLACK_IN         =>      txctrlack1_i,
 
        RXCTRLACK_IN         =>      rxctrlack1_i,
        GTHRESET_OUT         =>      init_gthreset1_i,
 
        TXPOWERDOWN_OUT      =>      init_txpowerdown1_i,
 
        RXPOWERDOWN_OUT      =>      init_rxpowerdown1_i,
 
        TXBUFRESET_OUT       =>      init_txbufreset1_i,
 
        RXBUFRESET_OUT       =>      init_rxbufreset1_i,
 
        TXRATE_OUT           =>      open,
 
        RXRATE_OUT           =>      open,
  
        SAMPLERATE_OUT       =>      open,
        RESETDONE_OUT        =>      init_resetdone1_i
    );

    gth1_init_rxbufreset_sync_i : v6_gthwizard_v1_11_caui_PULSE_SYNCHRONIZER 
    port map
    (
        SRCCLK_IN           =>      TXUSERCLKIN1_IN,
        DSTCLK_IN           =>      RXUSERCLKIN1_IN,
        SRCPULSE_IN         =>      init_rxbufreset1_i,
        PULSETYPE_IN        =>      tied_to_ground_i,
        DSTPULSE_OUT        =>      init_rxbufreset1_r
    );
 
    not_init_resetdone1_i    <= not init_resetdone1_i;

 
    gth1_tx_pcs_reset_i : v6_gthwizard_v1_11_caui_GTH_TX_PCS_RESET
    port map
    (
        TXUSERCLK_IN        =>      TXUSERCLKIN1_IN,
        RESET_IN            =>      not_init_resetdone1_i,
        TXPCSRESET_IN       =>      tx_pcs_reset1_i,
        TXCTRLACK_IN        =>      txctrlack1_i,
        TXBUFRESET_OUT      =>      pcs_txbufreset1_i,
        TXPOWERDOWN_OUT     =>      pcs_txpowerdown1_i,
        TXPCSRESETDONE_OUT  =>      tx_pcs_reset_done1_i
    );
 

 
    RXCTRLACK1_OUT      <= rxctrlack1_i;

 
    TXCTRLACK1_OUT  <= txctrlack1_i;
    tx_pcs_reset1_i <= TX_PCS_RESET1_IN;

    TX_PCS_RESETDONE1_OUT <= tx_pcs_reset_done1_i;

    txpowerdown1_i(1) <= init_txpowerdown1_i or (tx_pcs_reset_done1_i and TXPOWERDOWN1_IN(1)) or pcs_txpowerdown1_i;
    txpowerdown1_i(0) <= '0';
    txbufreset1_i <= init_txbufreset1_i or (tx_pcs_reset_done1_i and TXBUFRESET1_IN) or pcs_txbufreset1_i;

 
    gth1_rx_pcs_cdr_reset_i : v6_gthwizard_v1_11_caui_GTH_RX_PCS_CDR_RESET
    port map
    (
        TXUSERCLK_IN            =>      TXUSERCLKIN1_IN,
        RESET_IN                =>      not_init_resetdone1_i,
        RXPCSRESET_IN           =>      rx_pcs_cdr_reset1_r2,
        RXCTRLACK_IN            =>      rxctrlack1_i,
        RXBUFRESET_OUT          =>      pcs_rxbufreset1_i,
        RXPOWERDOWN_OUT         =>      pcs_rxpowerdown1_i,
        RXPCSCDRRESETDONE_OUT   =>      rx_pcs_cdr_reset_done1_i
    );

    gth1_rx_pcs_rxbufreset_sync_i : v6_gthwizard_v1_11_caui_PULSE_SYNCHRONIZER 
    port map
    (
        SRCCLK_IN               =>      TXUSERCLKIN1_IN,
        DSTCLK_IN               =>      RXUSERCLKIN1_IN,
        SRCPULSE_IN             =>      pcs_rxbufreset1_i,
        PULSETYPE_IN            =>      tied_to_ground_i,
        DSTPULSE_OUT            =>      pcs_rxbufreset1_r
    );    

    process (TXUSERCLKIN1_IN)
    begin
        if (rising_edge(TXUSERCLKIN1_IN)) then
            if (not_init_resetdone1_i = '1') then        
                rx_pcs_cdr_reset1_r  <= '0' after DLY;
                rx_pcs_cdr_reset1_r2 <= '0' after DLY;        
            else
                rx_pcs_cdr_reset1_r  <= RX_PCS_CDR_RESET1_IN after DLY;
                rx_pcs_cdr_reset1_r2 <= rx_pcs_cdr_reset1_r after DLY;
            end if;
        end if;
    end process;

    RX_PCS_CDR_RESETDONE1_OUT  <= rx_pcs_cdr_reset_done1_r2;

    rxpowerdown1_i(1) <= init_rxpowerdown1_i or (rx_pcs_cdr_reset_done1_tx_clk_r3 and RXPOWERDOWN1_IN(1)) or pcs_rxpowerdown1_i;
    rxpowerdown1_i(0) <= '0';
    
    rxbufreset1_txuserclk_domain_i <= init_rxbufreset1_r or pcs_rxbufreset1_r;
    rxbufreset1_i <= rxbufreset1_r2 or (rx_pcs_cdr_reset_done1_r2 and RXBUFRESET1_IN);


 
    process (TXUSERCLKIN1_IN)
    begin
        if (rising_edge(TXUSERCLKIN1_IN)) then    
            if (not_init_resetdone1_i = '1') then
                rx_pcs_cdr_reset_done1_tx_clk_r  <= '0' after DLY;
                rx_pcs_cdr_reset_done1_tx_clk_r2 <= '0' after DLY;
                rx_pcs_cdr_reset_done1_tx_clk_r3 <= '0' after DLY;
            else
                rx_pcs_cdr_reset_done1_tx_clk_r  <= rx_pcs_cdr_reset_done1_i after DLY;
                rx_pcs_cdr_reset_done1_tx_clk_r2 <= rx_pcs_cdr_reset_done1_tx_clk_r after DLY;
                rx_pcs_cdr_reset_done1_tx_clk_r3 <= rx_pcs_cdr_reset_done1_tx_clk_r2 after DLY;
            end if;
        end if;
    end process;

    -- Double flop to RXUSERCLK domain
    process (RXUSERCLKIN1_IN)
    begin
        if (rising_edge(RXUSERCLKIN1_IN)) then
            if (sync_reset1_r = '1') then        
                rx_pcs_cdr_reset_done1_r  <= '0' after DLY;
                rx_pcs_cdr_reset_done1_r2 <= '0' after DLY;        
            else
                rx_pcs_cdr_reset_done1_r  <= rx_pcs_cdr_reset_done1_tx_clk_r3 after DLY;
                rx_pcs_cdr_reset_done1_r2 <= rx_pcs_cdr_reset_done1_r after DLY;
            end if;
        end if;
    end process;
    rxbufreset1_r2 <= rxbufreset1_txuserclk_domain_i;

  
    gth2_init_i : v6_gthwizard_v1_11_caui_GTH_INIT
    generic map
    (
        FULL_RATE            =>      1,
        DIV_RATE             =>      "00"
    )
    port map
    (
        TXUSERCLK_IN         =>      TXUSERCLKIN2_IN,
        GTHRESET_IN          =>      GTHRESET_IN,
        GTHINITDONE_IN       =>      gthinitdone_i,
 
        TXCTRLACK_IN         =>      txctrlack2_i,
 
        RXCTRLACK_IN         =>      rxctrlack2_i,
        GTHRESET_OUT         =>      init_gthreset2_i,
 
        TXPOWERDOWN_OUT      =>      init_txpowerdown2_i,
 
        RXPOWERDOWN_OUT      =>      init_rxpowerdown2_i,
 
        TXBUFRESET_OUT       =>      init_txbufreset2_i,
 
        RXBUFRESET_OUT       =>      init_rxbufreset2_i,
 
        TXRATE_OUT           =>      open,
 
        RXRATE_OUT           =>      open,
  
        SAMPLERATE_OUT       =>      open,
        RESETDONE_OUT        =>      init_resetdone2_i
    );

    gth2_init_rxbufreset_sync_i : v6_gthwizard_v1_11_caui_PULSE_SYNCHRONIZER 
    port map
    (
        SRCCLK_IN           =>      TXUSERCLKIN2_IN,
        DSTCLK_IN           =>      RXUSERCLKIN2_IN,
        SRCPULSE_IN         =>      init_rxbufreset2_i,
        PULSETYPE_IN        =>      tied_to_ground_i,
        DSTPULSE_OUT        =>      init_rxbufreset2_r
    );
 
    not_init_resetdone2_i    <= not init_resetdone2_i;

 
    gth2_tx_pcs_reset_i : v6_gthwizard_v1_11_caui_GTH_TX_PCS_RESET
    port map
    (
        TXUSERCLK_IN        =>      TXUSERCLKIN2_IN,
        RESET_IN            =>      not_init_resetdone2_i,
        TXPCSRESET_IN       =>      tx_pcs_reset2_i,
        TXCTRLACK_IN        =>      txctrlack2_i,
        TXBUFRESET_OUT      =>      pcs_txbufreset2_i,
        TXPOWERDOWN_OUT     =>      pcs_txpowerdown2_i,
        TXPCSRESETDONE_OUT  =>      tx_pcs_reset_done2_i
    );
 

 
    RXCTRLACK2_OUT      <= rxctrlack2_i;

 
    TXCTRLACK2_OUT  <= txctrlack2_i;
    tx_pcs_reset2_i <= TX_PCS_RESET2_IN;

    TX_PCS_RESETDONE2_OUT <= tx_pcs_reset_done2_i;

    txpowerdown2_i(1) <= init_txpowerdown2_i or (tx_pcs_reset_done2_i and TXPOWERDOWN2_IN(1)) or pcs_txpowerdown2_i;
    txpowerdown2_i(0) <= '0';
    txbufreset2_i <= init_txbufreset2_i or (tx_pcs_reset_done2_i and TXBUFRESET2_IN) or pcs_txbufreset2_i;

 
    gth2_rx_pcs_cdr_reset_i : v6_gthwizard_v1_11_caui_GTH_RX_PCS_CDR_RESET
    port map
    (
        TXUSERCLK_IN            =>      TXUSERCLKIN2_IN,
        RESET_IN                =>      not_init_resetdone2_i,
        RXPCSRESET_IN           =>      rx_pcs_cdr_reset2_r2,
        RXCTRLACK_IN            =>      rxctrlack2_i,
        RXBUFRESET_OUT          =>      pcs_rxbufreset2_i,
        RXPOWERDOWN_OUT         =>      pcs_rxpowerdown2_i,
        RXPCSCDRRESETDONE_OUT   =>      rx_pcs_cdr_reset_done2_i
    );

    gth2_rx_pcs_rxbufreset_sync_i : v6_gthwizard_v1_11_caui_PULSE_SYNCHRONIZER 
    port map
    (
        SRCCLK_IN               =>      TXUSERCLKIN2_IN,
        DSTCLK_IN               =>      RXUSERCLKIN2_IN,
        SRCPULSE_IN             =>      pcs_rxbufreset2_i,
        PULSETYPE_IN            =>      tied_to_ground_i,
        DSTPULSE_OUT            =>      pcs_rxbufreset2_r
    );    

    process (TXUSERCLKIN2_IN)
    begin
        if (rising_edge(TXUSERCLKIN2_IN)) then
            if (not_init_resetdone2_i = '1') then        
                rx_pcs_cdr_reset2_r  <= '0' after DLY;
                rx_pcs_cdr_reset2_r2 <= '0' after DLY;        
            else
                rx_pcs_cdr_reset2_r  <= RX_PCS_CDR_RESET2_IN after DLY;
                rx_pcs_cdr_reset2_r2 <= rx_pcs_cdr_reset2_r after DLY;
            end if;
        end if;
    end process;

    RX_PCS_CDR_RESETDONE2_OUT  <= rx_pcs_cdr_reset_done2_r2;

    rxpowerdown2_i(1) <= init_rxpowerdown2_i or (rx_pcs_cdr_reset_done2_tx_clk_r3 and RXPOWERDOWN2_IN(1)) or pcs_rxpowerdown2_i;
    rxpowerdown2_i(0) <= '0';
    
    rxbufreset2_txuserclk_domain_i <= init_rxbufreset2_r or pcs_rxbufreset2_r;
    rxbufreset2_i <= rxbufreset2_r2 or (rx_pcs_cdr_reset_done2_r2 and RXBUFRESET2_IN);


 
    process (TXUSERCLKIN2_IN)
    begin
        if (rising_edge(TXUSERCLKIN2_IN)) then    
            if (not_init_resetdone2_i = '1') then
                rx_pcs_cdr_reset_done2_tx_clk_r  <= '0' after DLY;
                rx_pcs_cdr_reset_done2_tx_clk_r2 <= '0' after DLY;
                rx_pcs_cdr_reset_done2_tx_clk_r3 <= '0' after DLY;
            else
                rx_pcs_cdr_reset_done2_tx_clk_r  <= rx_pcs_cdr_reset_done2_i after DLY;
                rx_pcs_cdr_reset_done2_tx_clk_r2 <= rx_pcs_cdr_reset_done2_tx_clk_r after DLY;
                rx_pcs_cdr_reset_done2_tx_clk_r3 <= rx_pcs_cdr_reset_done2_tx_clk_r2 after DLY;
            end if;
        end if;
    end process;

    -- Double flop to RXUSERCLK domain
    process (RXUSERCLKIN2_IN)
    begin
        if (rising_edge(RXUSERCLKIN2_IN)) then
            if (sync_reset2_r = '1') then        
                rx_pcs_cdr_reset_done2_r  <= '0' after DLY;
                rx_pcs_cdr_reset_done2_r2 <= '0' after DLY;        
            else
                rx_pcs_cdr_reset_done2_r  <= rx_pcs_cdr_reset_done2_tx_clk_r3 after DLY;
                rx_pcs_cdr_reset_done2_r2 <= rx_pcs_cdr_reset_done2_r after DLY;
            end if;
        end if;
    end process;
    rxbufreset2_r2 <= rxbufreset2_txuserclk_domain_i;

  
    gth3_init_i : v6_gthwizard_v1_11_caui_GTH_INIT
    generic map
    (
        FULL_RATE            =>      1,
        DIV_RATE             =>      "00"
    )
    port map
    (
        TXUSERCLK_IN         =>      TXUSERCLKIN3_IN,
        GTHRESET_IN          =>      GTHRESET_IN,
        GTHINITDONE_IN       =>      gthinitdone_i,
 
        TXCTRLACK_IN         =>      txctrlack3_i,
 
        RXCTRLACK_IN         =>      rxctrlack3_i,
        GTHRESET_OUT         =>      init_gthreset3_i,
 
        TXPOWERDOWN_OUT      =>      init_txpowerdown3_i,
 
        RXPOWERDOWN_OUT      =>      init_rxpowerdown3_i,
 
        TXBUFRESET_OUT       =>      init_txbufreset3_i,
 
        RXBUFRESET_OUT       =>      init_rxbufreset3_i,
 
        TXRATE_OUT           =>      open,
 
        RXRATE_OUT           =>      open,
  
        SAMPLERATE_OUT       =>      open,
        RESETDONE_OUT        =>      init_resetdone3_i
    );

    gth3_init_rxbufreset_sync_i : v6_gthwizard_v1_11_caui_PULSE_SYNCHRONIZER 
    port map
    (
        SRCCLK_IN           =>      TXUSERCLKIN3_IN,
        DSTCLK_IN           =>      RXUSERCLKIN3_IN,
        SRCPULSE_IN         =>      init_rxbufreset3_i,
        PULSETYPE_IN        =>      tied_to_ground_i,
        DSTPULSE_OUT        =>      init_rxbufreset3_r
    );
 
    not_init_resetdone3_i    <= not init_resetdone3_i;

 
    gth3_tx_pcs_reset_i : v6_gthwizard_v1_11_caui_GTH_TX_PCS_RESET
    port map
    (
        TXUSERCLK_IN        =>      TXUSERCLKIN3_IN,
        RESET_IN            =>      not_init_resetdone3_i,
        TXPCSRESET_IN       =>      tx_pcs_reset3_i,
        TXCTRLACK_IN        =>      txctrlack3_i,
        TXBUFRESET_OUT      =>      pcs_txbufreset3_i,
        TXPOWERDOWN_OUT     =>      pcs_txpowerdown3_i,
        TXPCSRESETDONE_OUT  =>      tx_pcs_reset_done3_i
    );
 

 
    RXCTRLACK3_OUT      <= rxctrlack3_i;

 
    TXCTRLACK3_OUT  <= txctrlack3_i;
    tx_pcs_reset3_i <= TX_PCS_RESET3_IN;

    TX_PCS_RESETDONE3_OUT <= tx_pcs_reset_done3_i;

    txpowerdown3_i(1) <= init_txpowerdown3_i or (tx_pcs_reset_done3_i and TXPOWERDOWN3_IN(1)) or pcs_txpowerdown3_i;
    txpowerdown3_i(0) <= '0';
    txbufreset3_i <= init_txbufreset3_i or (tx_pcs_reset_done3_i and TXBUFRESET3_IN) or pcs_txbufreset3_i;

 
    gth3_rx_pcs_cdr_reset_i : v6_gthwizard_v1_11_caui_GTH_RX_PCS_CDR_RESET
    port map
    (
        TXUSERCLK_IN            =>      TXUSERCLKIN3_IN,
        RESET_IN                =>      not_init_resetdone3_i,
        RXPCSRESET_IN           =>      rx_pcs_cdr_reset3_r2,
        RXCTRLACK_IN            =>      rxctrlack3_i,
        RXBUFRESET_OUT          =>      pcs_rxbufreset3_i,
        RXPOWERDOWN_OUT         =>      pcs_rxpowerdown3_i,
        RXPCSCDRRESETDONE_OUT   =>      rx_pcs_cdr_reset_done3_i
    );

    gth3_rx_pcs_rxbufreset_sync_i : v6_gthwizard_v1_11_caui_PULSE_SYNCHRONIZER 
    port map
    (
        SRCCLK_IN               =>      TXUSERCLKIN3_IN,
        DSTCLK_IN               =>      RXUSERCLKIN3_IN,
        SRCPULSE_IN             =>      pcs_rxbufreset3_i,
        PULSETYPE_IN            =>      tied_to_ground_i,
        DSTPULSE_OUT            =>      pcs_rxbufreset3_r
    );    

    process (TXUSERCLKIN3_IN)
    begin
        if (rising_edge(TXUSERCLKIN3_IN)) then
            if (not_init_resetdone3_i = '1') then        
                rx_pcs_cdr_reset3_r  <= '0' after DLY;
                rx_pcs_cdr_reset3_r2 <= '0' after DLY;        
            else
                rx_pcs_cdr_reset3_r  <= RX_PCS_CDR_RESET3_IN after DLY;
                rx_pcs_cdr_reset3_r2 <= rx_pcs_cdr_reset3_r after DLY;
            end if;
        end if;
    end process;

    RX_PCS_CDR_RESETDONE3_OUT  <= rx_pcs_cdr_reset_done3_r2;

    rxpowerdown3_i(1) <= init_rxpowerdown3_i or (rx_pcs_cdr_reset_done3_tx_clk_r3 and RXPOWERDOWN3_IN(1)) or pcs_rxpowerdown3_i;
    rxpowerdown3_i(0) <= '0';
    
    rxbufreset3_txuserclk_domain_i <= init_rxbufreset3_r or pcs_rxbufreset3_r;
    rxbufreset3_i <= rxbufreset3_r2 or (rx_pcs_cdr_reset_done3_r2 and RXBUFRESET3_IN);


 
    process (TXUSERCLKIN3_IN)
    begin
        if (rising_edge(TXUSERCLKIN3_IN)) then    
            if (not_init_resetdone3_i = '1') then
                rx_pcs_cdr_reset_done3_tx_clk_r  <= '0' after DLY;
                rx_pcs_cdr_reset_done3_tx_clk_r2 <= '0' after DLY;
                rx_pcs_cdr_reset_done3_tx_clk_r3 <= '0' after DLY;
            else
                rx_pcs_cdr_reset_done3_tx_clk_r  <= rx_pcs_cdr_reset_done3_i after DLY;
                rx_pcs_cdr_reset_done3_tx_clk_r2 <= rx_pcs_cdr_reset_done3_tx_clk_r after DLY;
                rx_pcs_cdr_reset_done3_tx_clk_r3 <= rx_pcs_cdr_reset_done3_tx_clk_r2 after DLY;
            end if;
        end if;
    end process;

    -- Double flop to RXUSERCLK domain
    process (RXUSERCLKIN3_IN)
    begin
        if (rising_edge(RXUSERCLKIN3_IN)) then
            if (sync_reset3_r = '1') then        
                rx_pcs_cdr_reset_done3_r  <= '0' after DLY;
                rx_pcs_cdr_reset_done3_r2 <= '0' after DLY;        
            else
                rx_pcs_cdr_reset_done3_r  <= rx_pcs_cdr_reset_done3_tx_clk_r3 after DLY;
                rx_pcs_cdr_reset_done3_r2 <= rx_pcs_cdr_reset_done3_r after DLY;
            end if;
        end if;
    end process;
    rxbufreset3_r2 <= rxbufreset3_txuserclk_domain_i;

  




 
    txctrlack_i <= txctrlack0_i or txctrlack1_i or txctrlack2_i or txctrlack3_i;
 
 
    rxctrlack_i <= rxctrlack0_i or rxctrlack1_i or rxctrlack2_i or rxctrlack3_i;
 
    gthreset_rdy_i <= init_gthreset0_i or init_gthreset1_i or init_gthreset2_i or init_gthreset3_i;

    
    -- Double flop to DCLK domain
    process (DCLK_IN)
    begin
        if (rising_edge(DCLK_IN)) then
            if (GTHRESET_IN = '1') then
                rxctrlack_r  <= '0' after DLY;
                rxctrlack_r2 <= '0' after DLY;
            else
                rxctrlack_r  <= rxctrlack_i after DLY;
                rxctrlack_r2 <= rxctrlack_r after DLY;
            end if;
        end if;
    end process;
  

 
    -- Double flop to DCLK domain
    process (DCLK_IN)
    begin
        if (rising_edge(DCLK_IN)) then
            if (GTHRESET_IN = '1') then        
                txctrlack_r  <= '0' after DLY;
                txctrlack_r2 <= '0' after DLY;
            else
                txctrlack_r  <= txctrlack_i after DLY;
                txctrlack_r2 <= txctrlack_r after DLY;
            end if;
        end if;
    end process;
  

    -- Double flop to DCLK domain
    process (DCLK_IN)
    begin
        if (rising_edge(DCLK_IN)) then
            if (GTHRESET_IN = '1') then
                gthreset_rdy_r  <= '0' after DLY;
                gthreset_rdy_r2 <= '0' after DLY;
            else
                gthreset_rdy_r  <= gthreset_rdy_i after DLY;
                gthreset_rdy_r2 <= gthreset_rdy_r after DLY;
            end if;
        end if;
    end process;

end RTL;

 
