--
-- Copyright (c) 2015 Aitia International Inc.
--
-- See the file "/doc/license.txt" for information on usage and redistribution
-- of this file, and for a DISCLAIMER OF ALL WARRANTIES.
-- 
--------------------------------------------------------------------------------
-- Company: Aitia
-- Engineer: Laszlo Kovacs
--
-- Create Date:   08:05:16 06/03/2016
-- Design Name:   
-- Module Name:   /mnt/Adat2/MUNKA/SGA_CGEP/sim/sim_100G_full.vhd
-- Project Name:  sim
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- TestBench for 100G Ethernet PCS/PMA+MAC full model simulation
-- including Virtex 6 device specific transcievers
-- Contains a simple traffic geneartor
-- Serial GTH Serdes-level input/outputs are in loopback!
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE work.tuw.all; 
USE work.cgpcspma_v6.all;
USE work.cg_framegen_pkg.all;  
 
ENTITY sim_100G_full IS
END sim_100G_full;
 
ARCHITECTURE behavior OF sim_100G_full IS 
 
   --Inputs
   signal Q0_REFCLK_N : std_logic := '0';
   signal Q0_REFCLK_P : std_logic := '0';
   signal Q1_REFCLK_N : std_logic := '0';
   signal Q1_REFCLK_P : std_logic := '0';
   signal Q2_REFCLK_N : std_logic := '0';
   signal Q2_REFCLK_P : std_logic := '0';
   signal CG_ExtClk : std_logic := '0';
   SIGNAL DRP_Clk : STD_LOGIC := '0';
   signal RXN_GTH : std_logic_vector(11 downto 0) := (others => '0');
   signal RXP_GTH : std_logic_vector(11 downto 0) := (others => '0');
   signal CG_TXData : std_logic_vector(511 downto 0) := (others => '0');
   signal CG_TXMod64 : std_logic_vector(5 downto 0) := (others => '0');
   signal CG_TXDv : std_logic := '0';
   signal CG_TXSof : std_logic := '0';
   signal CG_TXEof : std_logic := '0';
   signal CG_Rst : std_logic := '0';
   signal CG_signal_ok : std_logic := '0';

 	--Outputs
   signal TXN_GTH : std_logic_vector(11 downto 0);
   signal TXP_GTH : std_logic_vector(11 downto 0);
   signal CG_Clk_RX : std_logic;
   signal CG_Clk_TX : std_logic;
   signal CG_RXData : std_logic_vector(511 downto 0);
   signal CG_RXMod64 : std_logic_vector(5 downto 0);
   signal CG_RXDv : std_logic;
   signal CG_RXSof : std_logic;
   signal CG_RXEof : std_logic;
   signal CG_RXErr : std_logic;
   signal CG_RXCRCErr : std_logic;
   signal CG_aligned : std_logic;
   signal CG_initdone : std_logic;
   SIGNAL PCS_RXSof : STD_LOGIC;

SIGNAL Cfg_Wr			: STD_LOGIC;
SIGNAL CG_TXAv			: STD_LOGIC;

SIGNAL RXPck_Cntr 	: STD_LOGIC_VECTOR(4*8-1 downto 0) := (others => '0');
SIGNAL MACRx_Loss 	: STD_LOGIC := '0';


   -- Clock period definitions
   constant CG_ExtClk_period : time := 10 ns; -- 50 MHz
   constant GTH_Clk_period : time := 6.4 ns; -- 156.25M GTH reference clock
   constant GTH_bClk_period : time := 96970 fs; -- 156.25Mx66b GTH bit clock
 
BEGIN
 
CG_signal_ok	<= '1'; 

-- LOOP PHYSICAL!
RXN_GTH		<= TXN_GTH;
RXP_GTH		<= TXP_GTH;


-- Instantiate the Unit Under Test (UUT)
   uut: ETH_100G_v6 PORT MAP (
          Q0_REFCLK_N 	=> Q0_REFCLK_N,
          Q0_REFCLK_P 	=> Q0_REFCLK_P,
          Q1_REFCLK_N 	=> Q1_REFCLK_N,
          Q1_REFCLK_P 	=> Q1_REFCLK_P,
          Q2_REFCLK_N 	=> Q2_REFCLK_N,
          Q2_REFCLK_P 	=> Q2_REFCLK_P,
		DRP_CLK		=> DRP_Clk,
          RXN_GTH 		=> RXN_GTH,
          RXP_GTH 		=> RXP_GTH,
          TXN_GTH 		=> TXN_GTH,
          TXP_GTH 		=> TXP_GTH,
		--
          CG_RXData 	=> CG_RXData,
          CG_RXMod64 	=> CG_RXMod64,
          CG_RXDv 		=> CG_RXDv,
          CG_RXSof 		=> CG_RXSof,
          CG_RXEof 		=> CG_RXEof,
          CG_RXErr 		=> CG_RXErr,
		CG_RXCRCErr	=> CG_RXCRCErr,
		PCS_RXSof		=> PCS_RXSof,
		--
		CG_TXAv		=> CG_TXAv,
          CG_TXData 	=> CG_TXData,
          CG_TXMod64 	=> CG_TXMod64,
          CG_TXDv 		=> CG_TXDv,
          CG_TXSof 		=> CG_TXSof,
          CG_TXEof 		=> CG_TXEof,
		--
          CG_Clk_RX		=> CG_Clk_RX,
          CG_Clk_TX		=> CG_Clk_TX,		
          CG_Rst 		=> CG_Rst,
		CG_CDR_Rst	=> CG_Rst,
          CG_signal_ok 	=> CG_signal_ok,
		CG_initdone	=> CG_initdone,
          CG_aligned 	=> CG_aligned
        );

-- Simple Frame generator
UCTxG: CG_FrameGen 
	PORT MAP(
	clk 						=> CG_Clk_TX,
	Rst 						=> CG_Rst,
	-- Config
	Cfg_Frlen					=> X"0040", --CGCfg_Frlen, 
	Cfg_Ifslen				=> X"0000", --CGCfg_Ifslen, 
	Cfg_Wr					=> Cfg_Wr,
	--
	CG_TxAv					=> CG_TXAv,
	CG_TXData 				=> CG_TXData,
	CG_TXDv 					=> CG_TXDv,
	CG_TXSof					=> CG_TXSof,
	CG_TXEof					=> CG_TXEof,
	CG_TXMod64				=> CG_TXMod64
	); 

-- Detect frame-loss
URXLoss: PROCESS(CG_Clk_RX)
BEGIN
IF (CG_Clk_RX'event AND CG_Clk_RX = '1') THEN
	IF (CG_RXSOF = '1' AND CG_RXDV = '1') THEN
		IF (RXPck_Cntr /= CG_RXData(5*64-1 downto 5*64-32)) THEN -- Packet number is in last 4 byte positions
			RXPck_Cntr	<= CG_RXData(5*64-1 downto 5*64-32) + X"00000001";
			MACRX_Loss 	<= '1';
		ELSE
			INCR(RXPck_Cntr);
			MACRX_Loss 	<= '0';
		END IF;
	ELSE
		MACRX_Loss 	<= '0';
	END IF;
END IF;
END PROCESS;



PROCESS(DRP_Clk)
BEGIN
IF (DRP_Clk'event AND DRP_Clk='1') THEN
IF (CG_Rst = '1') THEN
	Cfg_Wr	<= '0';
ELSE
	Cfg_Wr	<= '1';
END IF;
END IF;
END PROCESS;
 
DRP_Clk	<= CG_ExtClk;

   -- Clock process definitions
   CG_ExtClk_process :process
   begin
		CG_ExtClk <= '0';
		wait for CG_ExtClk_period/2;
		CG_ExtClk <= '1';
		wait for CG_ExtClk_period/2;
   end process;
 
   CG_Clk_process :process
   begin
		Q0_REFCLK_N <= '0';
		Q0_REFCLK_P <= '1';
		Q1_REFCLK_N <= '0';
		Q1_REFCLK_P <= '1';
		Q2_REFCLK_N <= '0';
		Q2_REFCLK_P <= '1';
		wait for GTH_Clk_period/2;
		Q0_REFCLK_N <= '1';
		Q0_REFCLK_P <= '0';
		Q1_REFCLK_N <= '1';
		Q1_REFCLK_P <= '0';
		Q2_REFCLK_N <= '1';
		Q2_REFCLK_P <= '0';
		wait for GTH_Clk_period/2;
   end process;
 
   -- Stimulus process
   stim_proc: process
   begin		
	CG_Rst	<= '1';
	wait until CG_initdone = '1'; 
      -- hold reset state for 100 ns after GTH initialized
     wait for 100 ns;	
	CG_Rst	<= '0';
      -- insert stimulus here 
      wait;
   end process;

END;
